/*******************************************************************
*******  Copyright (c)            Alexandros V. Gerbessiotis       *
******* All rights reserved; read copyag.txt file                  *
*******************************************************************/
#include "ssrt.h"
/* Standard quicksort(Hoare) with inline memcpy (mostly) and insertion sort  : tail recursion*/
/* 
 char* med50(char *a, char *b, char *c, int (*cmp)(const void *, const void *)) {
       return cmp(a, b) < 0 ?  (cmp(b, c) < 0 ? b : (cmp(a, c) < 0 ? c : a ))
                            :  (cmp(b, c) > 0 ? b : (cmp(a, c) < 0 ? a : c ));
 }
*/

void ag47qwr(void *akeys, int n, int size,int (*compare)(const void*,const void*))
{
  register int  M,c,l,r;
  register char *pi,*pl,*pr,*pp,*jp, *DES,*SRC;
  register char *keys=(char *) akeys, *split;


  if (n <= 1) return ; 
  split = (char*) malloc(size*sizeof(char));

  l=0; r=n-1;
  pl=keys+l*size  ; pr=keys+r*size;

#if SPLITTER == MIDDLE_KEY
    MEMCPY(split,keys+((l+r)>>1)*size,size);
#elif SPLITTER == FIRST_KEY
    MEMCPY(split,keys+l*size,size);
#elif SPLITTER == RANDOM_KEY
    MEMCPY(split,&keys[(l+GRANDOM((r-l+1)))*size],size);
#endif

  while (l <= r) {
       while (compare(pl,split)< 0) {l++; pl +=size;}
       while (compare(split,pr)< 0) {r--; pr -=size;}
       if (l <= r) { 
          /* MEMCPY(tmp,pl,size); MEMCPY(pl,pr,size); MEMCPY(pr,tmp,size);
    	     l++;r--;pl += size; pr -= size;
          */
          M=size;
          do { c=*pl; *pl++ = *pr; *pr++=c; } while (--M);
          l++; pr -=size; r--; pr -=size;
       }
  }
  
  if (r < (n-1-l)) { /* Left side smaller; eliminated a +1 from both sides */
      if ((r+1) < THRES16) {
                 if ((r) >0) { 
                  pi=keys;
                  for(jp=pi+size; jp< pi+(r+1)*size; jp +=size){
                    MEMCPY(split,jp,size);
                    for(pp=jp; pp >pi && (compare(pp-size,split)>0) ; pp-=size) {
                     MEMCPY((pp),(pp-size),size);
                    }
                    MEMCPY((pp),split,size);
                  }
                 }
      }
      else {
         ag47qwr(keys,r+1,size,compare);
      }
  } /*left */
  else {               /* Right side smaller */
      if ((n-l) < THRES16) {
               if ((n-l) >0) { 
               pi=keys+l*size;
               for(jp=pi+size;jp<pi+(n-l)*size;jp+=size){
                    MEMCPY(split,jp,size);
                    for(pp=jp; pp >pi && (compare(pp-size,split)>0) ; pp-=size) {
                     MEMCPY((pp),(pp-size),size);
                    }
                    MEMCPY((pp),split,size);
               }
              }
      }
      else {
        ag47qwr (keys+l*size,n-l,size,compare);
      }
      
  } /*right*/
 }


void ag47qw(void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  ag47qwr(keys,n,size,compare);
}
