/*******************************************************************
*******  Copyright (c)            Alexandros V. Gerbessiotis       *
******* All rights reserved; read copyag.txt file                  *
*******************************************************************/
#include "ssrt.h"

void ag48qwrr(void *akeys, int   n,int size,int (*compare)(const void*,const void*))
{
register int  M,c,i,j;
register char *pi,*pj,*SRC,*DES;
register char *keys=(char*) akeys, *split;

if (n <= 1) return ;
split=(char*)malloc(size*sizeof(char));

i=0;j=n-1;
pi=keys+i*size;  pj=keys+j*size;

#if SPLITTER == MIDDLE_KEY
 MEMCPY(split,keys+((i+j)>>1)*size,size);
#elif SPLITTER == FIRST_KEY
 MEMCPY(split,&keys[i*size],size);
#elif SPLITTER == RANDOM_KEY
 MEMCPY(split,&keys[(i+GRANDOM((j-i+1)))*size],size);
#endif

while (i <= j) {
    while (compare(pi,split)<0) {i++;pi +=size;}
    while (compare(split,pj)<0) {j--;pj -=size;}
    if (i <= j) {
       /* MEMCPY(tmp,pi,size); MEMCPY(pi,pj,size); MEMCPY(pj,tmp,size);
          i++;j--;pi += size; pj -= size;
       */
       M=size;
       do  { c=*pi; *pi++=*pj;*pj++=c;} while (--M);
       i++;j--;pj-=size;pj-=size;
    }
 }
  
 if (j > 0) {
      if ((j+1)<THRES16) {
          BASES (keys,j+1,size,compare);
      }
      else ag48qwrr(keys,j+1,size,compare);
  }
  if (i < n) {
      if ((n - i)<THRES16) {
          BASES (&keys[i*size],n-i,size,compare);
      }
      else ag48qwrr(keys+i*size,n-i,size,compare);
  }

 free((void *)split);
}
           
void ag48qw(void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  ag48qwrr(keys,n,size,compare);
}
