/*******************************************************************
*******  Copyright (c)            Alexandros V. Gerbessiotis       *
******* All rights reserved; read copyag.txt file                  *
*******************************************************************/
#include "ssrt.h"

void ag48qwro (void *akeys, int   n,int size,int (*compare)(const void*,const void*))
{
register int  M,c,i,j;
register char *pi,*pj,*pp,*SRC,*DES;
register char *keys=(char*) akeys, *split;
static char X[64];

 if (n <= 1) return ;
 split=X;

 i=0;j=n-1;
 pi=keys+i*size;  pj=keys+j*size;
#if SPLITTER == MIDDLE_KEY
 MEMCPY(split,keys+((i+j)>>1)*size,size);
#elif SPLITTER == FIRST_KEY
 MEMCPY(split,&keys[i*size],size);
#elif SPLITTER == RANDOM_KEY
 MEMCPY(split,&keys[(i+GRANDOM((j-i+1)))*size],size);
#endif

  while (i <= j) {
      while (compare(pi,split)<0) {i++;pi +=size;}
      while (compare(split,pj)<0) {j--;pj -=size;}
      if (i <= j) {
         /* MEMCPY(tmp,pi,size); MEMCPY(pi,pj,size); MEMCPY(pj,tmp,size);
            i++;j--;pi += size; pj -= size;
         */
         M=size;
         do  { c=*pi; *pi++=*pj;*pj++=c;} while (--M);
         i++;j--;pj-=size;pj-=size;
      }
  }
  
  if (j > 0) {
      if ((j+1)<THRES16) {
                   pi=keys;
                   for(pj=pi+size;pj< pi+(j+1)*size;pj+=size){
		     MEMCPY(split,pj,size);
                     for(pp=pj;pp > pi &&(compare(pp-size,split)>0); pp-=size){
                       MEMCPY((pp),(pp-size),size);
                     }
                     MEMCPY((pp),split,size);
                   }
      }
      else ag48qwro(keys,j+1,size,compare);
  }
  if (i < n) {
      if ((n - i)<THRES16) {
                   pi=keys+i*size;
                   for(pj=pi+size;pj< pi+(n-i)*size;pj+=size){
		     MEMCPY(split,pj,size);
                     for(pp=pj;pp > pi &&(compare(pp-size,split)>0); pp-=size){
                       MEMCPY((pp),(pp-size),size);
                     }
                     MEMCPY((pp),split,size);
                   }
      }
      else ag48qwro(keys+i*size,n-i,size,compare);
  }
}
           
void ag48qwo(void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  ag48qwro(keys,n,size,compare);
}
