/**** 2019 (c)  All rights reserved: see agcopy19.txt ****/
#include "agssrt.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif
 /* QuickSort Recursive using while ; no   optimizations  */
void q6qkrw0a(void *akeys, int n, int size, int (*compare) (const void*,const void*), int l, int r)
{
  register int M;
  register char *SRC, *DES;
  register char *keys = (char*) akeys;
  register char *split,*tmp,*pm;
  register int i,j;

  if (l>=r) return;
  keys = (char *) akeys;
  tmp  = (char *) malloc(size*sizeof(char));
  split= (char *) malloc(size*sizeof(char));
#if SPLITTER == MIDDLE_KEY
  pm = keys+((l+r)>>1)*size;
#elif SPLITTER == FIRST_KEY
  pm = keys+l*size ;
#elif SPLITTER == RANDOM_KEY
  pm = keys+(l+GRANDOM((r-l+1)))*size;
#endif
  MEMCPY(split,pm,size);
  MEMCPY(pm,keys+r*size,size);
  MEMCPY(keys+r*size,split,size);
  /* MEMCPY(split,&keys[r*size],size); */
 i=l; j=r-1;
 while (i<=j) {
   while ((i<=j) && (compare(&keys[i*size],split) <= 0))  ++i;
   while ((j>=i) && (compare(&keys[j*size],split) >= 0))  --j;
   if (i<j)  {
     MEMCPY(tmp,&keys[i*size],size);
     MEMCPY(&keys[i*size],&keys[j*size],size);
     MEMCPY(&keys[j*size],tmp,size);
   }
 }

 MEMCPY(tmp,&keys[i*size],size);
 MEMCPY(&keys[i*size],&keys[r*size],size);
 MEMCPY(&keys[r*size],tmp,size);

   M=i;
   q6qkrw0a(akeys,n,size,compare,l,i-1);
   q6qkrw0a(akeys,n,size,compare,i+1,r);
}

void q6qkrw0  (void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
  q6qkrw0a  (keys,n,size,compare,0,n-1);
}




 /* QuickSort Recursive using while ; some optimizations  */
void q6qkrw1a(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
  register int M;
  register char *SRC, *DES;
  register char *keys = (char*) akeys;
  register int  i, j,c;
  register char *x,*y,*pi,*pj;

  if (n <= 1) return ;
  i=0;j=n-1;
  x   = (char *) malloc(size*sizeof(char));
  y   = (char *) malloc(size*sizeof(char));
  pi= keys+i*size ;
  pj= keys+j*size ;
  /* memcpy(mid,&keys[0],size); */
#if SPLITTER == MIDDLE_KEY
 MEMCPY(x,&keys[((i+j)>>1)*size],size);
#elif SPLITTER == FIRST_KEY
 MEMCPY(x,&keys[i*size],size);
#elif SPLITTER == RANDOM_KEY
 MEMCPY(x,&keys[(i+GRANDOM((j-i+1)))*size],size);
#endif
  MEMCPY(x,&keys[((i+j)>>1)*size],size);

  while (i <= j) {
      while (compare(pi,x)<0) {++i;pi +=size;}
      while (compare(x,pj)<0) {--j;pj -=size;}
      if (i <= j) {
/*  commented out in 2019 and replace with inline below
          MEMCPY(y,pi,size);
          MEMCPY(pi,pj,size);
          MEMCPY(pj,y,size);
          ++i;--j;pi += size; pj -= size;
*/
         M=size;
          do  {
             c=*pi; *pi++=*pj;*pj++=c;} while (--M);
                ++i;--j;pj-=size;pj-=size;
      }
  }

  if (j > 0) {
      if ((j + 1) < RQSSZE ) RQSIS (keys, j + 1,size,compare) ;
      else q6qkrw1a(keys, j + 1,size,compare) ;
  }
  if (i < n) {
      if ((n - i) < RQSSZE ) RQSIS (keys+i*size, n - i,size,compare) ;
      else q6qkrw1a(keys+i*size , n - i,size,compare) ;
  }
 free((void *)x); free((void *)y);
}

void q6qkrw1(void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  q6qkrw1a(keys,n,size,compare);
}


 /* QuickSort Recursive using while ; inline insertion sort for-for , static X [64] */
void q6qkrw2a(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
  register int M;
  register char *SRC, *DES;
  register char *keys=(char*) akeys;
  register int i,j,c;
  register char *x,*pi,*pj,*pp;
  static char X[64];

  if (n <= 1) return ;
  i=0;  j=n-1;   x=X;   pi=keys+i*size;    pj=keys+j*size;
#if SPLITTER == MIDDLE_KEY
 MEMCPY(x,&keys[((i+j)>>1)*size],size);
#elif SPLITTER == FIRST_KEY
 MEMCPY(x,&keys[i*size],size);
#elif SPLITTER == RANDOM_KEY
 MEMCPY(x,&keys[(i+GRANDOM((j-i+1)))*size],size);
#endif
  while (i <= j) {
      while (compare(pi,x)<0) {++i;pi +=size;}
      while (compare(x,pj)<0) {--j;pj -=size;}
      if (i <= j) {
          /* MEMCPY(tmp,pi,size); MEMCPY(pi,pj,size); MEMCPY(pj,tmp,size);
             ++i;--j;pi += size; pj -= size; */
          M=size;
          do  {
             c=*pi; *pi++=*pj;*pj++=c;} while (--M);
                ++i;--j;pj-=size;pj-=size;
       }
   }
  if (j > 0) {
      if ((j+1)< RQSSZE) {
                   pi=keys;
                   for(pj=pi+size;pj< pi+(j+1)*size;pj+=size){
                     MEMCPY(x,pj,size);
                     for(pp=pj;pp > pi &&(compare(pp-size,x)>0); pp-=size){
                       MEMCPY((pp),(pp-size),size);
                     }
                     MEMCPY((pp),x,size);
                   }
      }
      else q6qkrw2a (keys,j+1,size,compare);
  }
  if (i < n) {
      if ((n - i)< RQSSZE) {
                   pi=keys+i*size;
                   for(pj=pi+size;pj< pi+(n-i)*size;pj+=size){
                     MEMCPY(x,pj,size);
                     for(pp=pj;pp > pi &&(compare(pp-size,x)>0); pp-=size){
                       MEMCPY((pp),(pp-size),size);
                     }
                     MEMCPY((pp),x,size);
                   }
      }
      else q6qkrw2a (&keys[i*size],n-i,size,compare);
  }
}

void q6qkrw2 (void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  q6qkrw2a (keys,n,size,compare);
}



/*
char* medr50(char *a, char *b, char *c, int (*cmp)(const void *, const void *))
{
 return cmp(a, b) < 0 ?  (cmp(b, c) < 0 ? b : (cmp(a, c) < 0 ? c : a ))
                      :  (cmp(b, c) > 0 ? b : (cmp(a, c) < 0 ? a : c ));
}
*/


 /* QuickSort Recursive using while ; TAIL recursion  insertion sort for-while some optimizations  */

void q6qkrw3a(void *akeys, int n, int size, int (*compare) (const void*,const void*), int *L, int *R)
{
  register int M;
  register char *SRC, *DES;
  register char *keys=(char*) akeys;
  register int I,J,l,r,mL,mR,c;
  register char *pi,*pj,*pl,*pr,*split;

  if ((*R-*L+1) <= 1) return ; /* tmp  = (char *) malloc(size*sizeof(char)); */
  split= (char *) malloc(size*sizeof(char));
  mL=*L;mR=*R;
  while (mL < mR ) {
     l=mL;r=mR;
     pl=keys+l*size ;
     pr=keys+r*size ;
/* pm=keys+((l+r)/2)*size; pm = medr50(pl, pm , pr,compare); MEMCPY(split,pm,size); */
#if SPLITTER == MIDDLE_KEY
    MEMCPY(split,&keys[((l+r)>>1)*size],size);
#elif SPLITTER == FIRST_KEY
    MEMCPY(split,&keys[l*size],size);
#elif SPLITTER == RANDOM_KEY
    MEMCPY(split,&keys[(l+GRANDOM((r-l+1)))*size],size);
#endif

     while (l <= r) {
         while (compare(pl,split)<0) {++l;pl +=size;}
         while (compare(split,pr)<0) {--r;pr -=size;}
         if (l <= r) { /* is it ok if < ? */
             /* MEMCPY(tmp,pl,size); MEMCPY(pl,pr,size); MEMCPY(pr,tmp,size);
             ++l;--r;pl += size; pr -= size; */
               M=size;
               do {
                c=*pl; *pl++ = *pr; *pr++=c;
               } while (--M);
               ++l; pr -=size;
               --r; pr -=size;

         }
     }
 
  if ((r-mL+1) < (mR-l+1)) { /* Left side smaller */
      if ((r-mL+1) < RQSSZE ) {
                 if ((r-mL+1) >1) {
                  pi=&keys[mL*size];
                  for(J=1;J<(r-mL+1);++J){
                    MEMCPY(split,(pi+J*size),size);
                    I=J-1;pj=pi+I*size;
                    while ((I>=0) && (compare(pj,split)>0) ) {
                     MEMCPY((pj+size),(pj),size);
                     I--;pj-=size;
                    }
                    MEMCPY((pj+size),split,size);
                  }
                 }
          mL=l;
      }
      else {
         *R=r; *L=mL; /* mL...r */
         q6qkrw3a(keys,(r-mL+1),size,compare,L,R);
         mL=l;  /* OR r l ..mR */
      }
   } /*left */
  else {               /* Right side smaller */
      if ((mR-l+1) < RQSSZE ) {
                          if ((mR-l+1) >1) {
               pi=&keys[(l)*size];
               for(J=1;J<(mR-l+1);J++){
                 MEMCPY(split,(pi+J*size),size);
                 I=J-1;pj=pi+I*size;
                 while ((I>=0) && (compare(pj,split)>0) ) {
                  MEMCPY((pj+size),(pj),size);
                  I--;pj-=size;
                 }
                 MEMCPY((pj+size),split,size);
            }
           }
       mR=r;
      }
      else {
        *L=l; *R=mR;  /* l...mR */
        q6qkrw3a(keys,mR-l+1,size,compare,L,R);
        mR=r;  /* mL ...r */
      }

  } /*right*/
 }
free((void *)split); /* free((void *)tmp); */
}

void q6qkrw3 (void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  int myL,myR;
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  myL=0;myR=n-1;
  q6qkrw3a (keys,n,size,compare,&myL,&myR);
}


 /* QuickSort Recursive using while ; TAIL recursion  insertion sort for-while some optimizations  */

void q6qkrw4a(void *akeys, int n, int size, int (*compare) (const void*,const void*), int *L, int *R)
{
  register int M;
  register char *SRC, *DES;
  register char *keys=(char*) akeys;
  register int l,r,mL,mR,c;
  register char *pi,*pl,*pr,*pp,*jp,*split;

  if ((*R-*L+1) <= 1) return ; /* tmp  = (char *) malloc(size*sizeof(char)); */
  split= (char *) malloc(size*sizeof(char));
  mL=*L;mR=*R;
  while (mL < mR ) {
     l=mL;r=mR;
     pl=keys+l*size ;
     pr=keys+r*size ;
/* pm=keys+((l+r)/2)*size; pm = medr50(pl, pm , pr,compare); MEMCPY(split,pm,size); */
/*
#if SPLITTER == MIDDLE_KEY
*/
    MEMCPY(split,&keys[((l+r)>>1)*size],size);
/*
#elif SPLITTER == FIRST_KEY
    MEMCPY(split,&keys[l*size],size);
#elif SPLITTER == RANDOM_KEY
    MEMCPY(split,&keys[(l+GRANDOM((r-l+1)))*size],size);
#endif
*/

     while (l <= r) {
         while (compare(pl,split)<0) {++l;pl +=size;}
         while (compare(split,pr)<0) {--r;pr -=size;}
         if (l <= r) { /* is it ok if < ? */
             /* MEMCPY(tmp,pl,size); MEMCPY(pl,pr,size); MEMCPY(pr,tmp,size);
             ++l;--r;pl += size; pr -= size; */
               M=size;
               do {
                c=*pl; *pl++ = *pr; *pr++=c;
               } while (--M);
               ++l; pr -=size;
               --r; pr -=size;

         }
     }
 
  if ((r-mL+1) < (mR-l+1)) { /* Left side smaller */
      if ((r-mL+1) < RQSSZE ) {
                  pi=keys+mL*size;
                  for(jp=pi+size; jp< pi+(r-mL+1)*size; jp +=size){
                    MEMCPY(split,jp,size);
                    for(pp=jp; pp >pi && (compare(pp-size,split)>0) ; pp-=size) {
                     MEMCPY((pp),(pp-size),size);
                    }
                    MEMCPY((pp),split,size);
                  }
          mL=l;
      }
      else {
         *R=r; *L=mL; /* mL...r */
         q6qkrw4a(keys,(r-mL+1),size,compare,L,R);
         mL=l;  /* OR r l ..mR */
      }
   } /*left */
  else {               /* Right side smaller */
      if ((mR-l+1) < RQSSZE ) {
               pi=keys+l*size;
               for(jp=pi+size;jp<pi+(mR-l+1)*size;jp+=size){
                    MEMCPY(split,jp,size);
                    for(pp=jp; pp >pi && (compare(pp-size,split)>0) ; pp-=size) {
                     MEMCPY((pp),(pp-size),size);
                    }
                    MEMCPY((pp),split,size);
               }
       mR=r;
      }
      else {
        *L=l; *R=mR;  /* l...mR */
        q6qkrw4a(keys,mR-l+1,size,compare,L,R);
        mR=r;  /* mL ...r */
      }

  } /*right*/
 }
free((void *)split); /* free((void *)tmp); */
}

void q6qkrw4 (void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  int myL,myR;
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  myL=0;myR=n-1;
  q6qkrw4a (keys,n,size,compare,&myL,&myR);
}


 /* QuickSort Recursive using while ; CAR Hoare TAIL recursion  insertion sort for-for   some optimizations  */

void q6qkrw5a(void *akeys, int n, int size, int (*compare) (const void*,const void*), int *L, int *R)
{
  register int M;
  register char *SRC, *DES;
  register char *keys=(char*) akeys;
  register int l,r,mL,mR,c;
  register char *pi,*jp,*pl,*pr,*pp,*split;
  /* static char X[64]; */

  if ((*R-*L) <= 0) return ; /* if ((*R-*L+1) <= 1) return ; */
  split = (char*) malloc(size*sizeof(char));  /* split =X */
  mL=*L;mR=*R;
  while (mL < mR ) {
     l=mL;r=mR;
     pl=keys+l*size;
     pr=keys+r*size;
     /* pm=keys+((l+r)/2)*size; pm = med50(pl, pm , pr,compare); MEMCPY(split,pm,size); */
#if SPLITTER == MIDDLE_KEY
    MEMCPY(split,&keys[((l+r)>>1)*size],size);
#elif SPLITTER == FIRST_KEY
    MEMCPY(split,&keys[l*size],size);
#elif SPLITTER == RANDOM_KEY
    MEMCPY(split,&keys[(l+GRANDOM((r-l+1)))*size],size);
#endif

     while (l <= r) {
         while (compare(pl,split)<0) {++l;pl +=size;}
         while (compare(split,pr)<0) {--r;pr -=size;}
         if (l <= r) { /* is it ok if < ? */
             /* MEMCPY(tmp,pl,size); MEMCPY(pl,pr,size); MEMCPY(pr,tmp,size);
             ++l;--r;pl += size; pr -= size; */
               M=size;
               do {
                c=*pl; *pl++ = *pr; *pr++=c;
               } while (--M);
               ++l; pr -=size;
               --r; pr -=size;

         }
     }
 
  if ((r-mL) < (mR-l)) { /* Left side smaller ; eliminated +1 from both sides */
      if ((r-mL+1) < RQSSZE ) {
                 if ((r-mL  ) > 0) { /*  +1 > 1 */
                  pi=keys+mL*size;
                  for(jp=pi+size; jp< pi+(r-mL+1)*size; jp +=size){
                    MEMCPY(split,jp,size);
                    for(pp=jp; pp >pi && (compare(pp-size,split)>0) ; pp-=size) {
                     MEMCPY((pp),(pp-size),size);
                    }
                    MEMCPY((pp),split,size);
                  }
                 }
          mL=l;
      }
      else {
         *R=r; *L=mL; /* mL...r */
         q6qkrw5a(keys,(r-mL+1),size,compare,L,R);
         mL=l;  /* OR r l ..mR */
      }
   } /*left */
  else {               /* Right side smaller */
      if ((mR-l+1) < RQSSZE ) {
                          if ((mR-l  ) >0) { /* +1 > 1 */
               pi=keys+l*size;
              for(jp=pi+size;jp<pi+(mR-l+1)*size;jp+=size){
                    MEMCPY(split,jp,size);
                    for(pp=jp; pp >pi && (compare(pp-size,split)>0) ; pp-=size) {
                     MEMCPY((pp),(pp-size),size);
                    }
                    MEMCPY((pp),split,size);
            }
           }
       mR=r;
      }
      else {
        *L=l; *R=mR;  /* l...mR */
        q6qkrw5a(keys,mR-l+1,size,compare,L,R);
        mR=r;  /* mL ...r */
      }

  } /*right*/
 }
free((void *)split); /* free((void *)tmp); */
}

void q6qkrw5 (void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  int myL,myR;
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  myL=0;myR=n-1;
  q6qkrw5a (keys,n,size,compare,&myL,&myR);
}


/************************
 * Note : code differs from CLR Hoare code in the following respect
 *  say input 10 9 8 7 5 and splitter is middle key 8
 *  at termination we have say l=1 r=5 in the beginning
 *            6 7  8 9 10
 *              r    l
 *  lest partition is 6 7 and right partion is ? 9 10 or  8 9 10?
 *  if all keys are equal
 *            8 8  8  8 8
 *              r     l   at termination
 *  In the g67.c code which is similar (but original and possibly primitive)
 *  left set is L ... r of size r-L+1   base left set keys[L*size]
 *  righ set is l ... R of size R-l+1 correctly identifies keys[l*size]
 *  if g68 and also by extension in g268 we used (pending before potential changes)
 *  left set is size r+1 and right set of size n-l which does not make much sense.
 */



