/**** 2019 (c)  All rights reserved: see agcopy19.txt ****/
#include "agssrti.h"
#ifndef IMEMCPY
#define IMEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE*sizeof(int)))
#endif
 /* Iterative MergeSort with baseline InsertionSort */

void i4mrgit1(int    *keys,int n)
{
#ifndef IMEMCPY
 register int M;
 register char *SRC, *DES;
#else
 register int M;
 register int  *SRC, *DES;
#endif
 register int    *S, *D, *T, *kys;
 register int i, j, k, r, t, LB, RB;
 int      *ktmp;

 if (n <  2   ) return;
 kys  = keys ;
 ktmp = (int    *) malloc(n*sizeof(int   ));

 for(t=0; t < n ; t+=BSRTSZE) {
    MRGBSRTI(kys + t, MIN(BSRTSZE, (n-t)));
 }

 S=kys; D=ktmp;
 for(r= BSRTSZE ; r < n ; r = (r<<1)) {
     for(t=0 ; t < n; t += (r<<1)) {
        LB=MIN(t+r, n); RB=MIN(t+(r<<1), n);
        i = t ; j = LB ; k = t;
        while ((i< LB) && (j< RB)) {
           if (S[j] < S[i]) {
              D[k] = S[j];
              ++j; ++k;
           }
           else {
              D[k] = S[i];
              ++i;++k;
           }
         }

#ifndef IMEMCPY
         if (i< LB)  MEMCPY((char*)(D+k), (char*)(S+i), (LB-i)*sizeof(int   ));
         if (j< RB)  MEMCPY((char*)(D+k), (char*)(S+j), (RB-j)*sizeof(int   ));
#else
         if (i< LB) IMEMCPY(       (D+k),        (S+i), (LB-i)               );
         if (j< RB) IMEMCPY(       (D+k),        (S+j), (RB-j)               );
#endif
      }
      T=S; S=D; D=T;
 }

#ifndef IMEMCPY
  if (S!=kys)  MEMCPY((char*)kys,(char*)S,n*sizeof(int   ));
#else
  if (S!=kys) IMEMCPY(       kys,       S,n               );
#endif
  free(ktmp);
}

/* Potential Improvement MEMCPY replaced by IMEMCPY that copies integers then
 * sizeof(int) removed in three instances
 */

/* IMEMCPY changes not propagated to d... or f.... */
