/*******************************************************************
*******  Copyright (c)            Alexandros V. Gerbessiotis       *
******* All rights reserved; read copyag.txt file                  *
*******************************************************************/
#include "ssrt.h"
#include "avgmain.h"
#define ALL_FUNCTIONS
#undef  ALL_FUNCTIONS
#undef  FEW_FUNCTIONS
#define FEW_FUNCTIONS
/*
#define Malloc(X,Y) malloc((X))
#define Free(X,Y,Z)   free((X))
*/

#define N_SORT_ALGS 21
#define DEBUG 0

int compare(const void *x,const void *y)
{
	return(int)(* ((data*)x)-*((data*)y));
}

int main(int argc,char *argv[]) {
  int i,j,k,n,runs, type;
  data *ptr,*bptr, *obptr;
  double elapsed;

  void (*gfunc[N_SORT_ALGS])() = {  
qsort, gnu01, gnu02, 
avg50qw, oavg50qw, ravg50qw,
avg51qd, oavg51qd, ravg51qd,
avg59qw, oavg59qw, ravg59qw,
avg30mi, avg34mi, avg40mi, 
oavg30mi, 
oavg43hx, avg43hx, 
oavg45hx, avg45hx, 
qsort
  };

  char *labels[N_SORT_ALGS]   = { 
"qsort", "gnu01", "gnu02", 
"avg50qw", "oavg50qw", "ravg50qw",
"avg51qd", "oavg51qd", "ravg51qd",
"avg59qw", "oavg59qw", "ravg59qw",
"avg30mi", "avg34mi",  "avg40mi", 
"oavg30mi", 
"oavg43hx", "avg43hx", "oavg45hx", "avg45hx", 
"qsort"
  };

  int doalg[N_SORT_ALGS] = { 
1,1,1,
1,1,1,
1,1,1,
1,1,1,
1,1,1,
1,
1,1,1,1,1
  };
/*
1,0,0,
0,0,1,
1,1,1,0,
0,0,0,0,
0,0,
0,0,
  0,0,1,
1,1,1,1,1,
0,0,0,0,
0,0,
0,0,1
*/

/*
1,0,0,
1,1,
0,0,0,0,
2,2,0,0,
0,0,
0,0,
1,1,
1,1,1,1,
0,0,0,0,
0,0,
0,0
*/


  void (*GTYPESORT)(void *,int,int,int (*) (const void *,const void *));

  n=1000;runs=1;
  if (( argc <= 1 ) || (argc > 4)) {
    printf("Usage: %s size runs type\nDEFAULTS= THRES16=%d TMERGE=%d SPLITTER=%d (0:left,1:middle,2:random)\nType 1=rand MODULO_UINT, 2=rand (INT_MAX), 3= 10, 4=i 5 =n-i+1\n",argv[0],THRES16,TMERGE,SPLITTER);
    return(1);
  } 
  else {
    n = atoi(argv[1]);
    runs=atoi(argv[2]);
    type=atoi(argv[3]);
   }

/*
   ptr = (data*) Malloc(n*sizeof(data),"ptr ");
   bptr= (data*) Malloc(n*sizeof(data),"bptr ");
*/
   ptr = (data*) malloc(n*sizeof(data));
   bptr= (data*) malloc(n*sizeof(data));
   obptr= (data*) malloc(n*sizeof(data));
   memset( ptr,0,n*sizeof(data));
   memset(bptr,0,n*sizeof(data));
   memset(obptr,0,n*sizeof(data));

   srandom(21+1001*11);
   for(i=0;i<n;i++)  {
    if  ( type==1 ) {
     bptr[i]=ptr[i]=(data) (random()&MODULO_UINT);
    }
    if  ( type==2 ) {
     bptr[i]=ptr[i]=(int) ((n)*(random()/((double)INT_MAX)));
    }
    if  ( type==3 ) {
     bptr[i]=ptr[i]=(int) 10;
    }
    if  ( type==4 ) {
     bptr[i]=ptr[i]=(int) i;
    }
    if  ( type>=5 ) {
     bptr[i]=ptr[i]=(int) n-i+1;
    }
   }

  
/*
     bptr[i]=ptr[i]=(int) ((n)*(random()/((double)INT_MAX)));
     bptr[i]=ptr[i]=(int) random();
   for(k=0;k<1          ;k++) {
*/
        if (DEBUG) { \
        printf("%6d(%2d %2d)In :",n,THRES16,THRES16);\
        for(i=0;i<ELMNTS;i++) printf("%d ",(int)ptr[i]); printf("..."); \
        for(i=n-ELMNTS;i<n;i++) printf("%d ",(int)ptr[i]); printf("\n");\
        }
     qsort(ptr,n,sizeof(data),compare);
     memcpy(obptr,ptr,n*sizeof(data));
        if (DEBUG) { \
        printf("%6d(%2d %2d)Out :",n,THRES16,THRES16);\
        for(i=0;i<ELMNTS;i++) printf("%d ",(int)obptr[i]); printf("..."); \
        for(i=n-ELMNTS;i<n;i++) printf("%d ",(int)obptr[i]); printf("\n");\
        }

   for(k=0;k<N_SORT_ALGS;k++) {
    if (doalg[k]>=1) {
     GTYPESORT=gfunc[k];
     WRITELINE1; WRITE1;
     GTYPESORT(ptr,n,sizeof(data),compare);
     WRITE2; WRITELINE2; CHECKLINE;
     if (memcmp(ptr,obptr,n*sizeof(data))  != 0)
        printf("ERR %18s generic: Elapsed time is: %10.8f\n",labels[k],elapsed/runs);
     else
        printf("    %18s generic: Elapsed time is: %10.8f\n",labels[k],elapsed/runs);
    }
   }

/*
   Free((void *) bptr,n*sizeof(data),"bptr");
   Free((void *) ptr,n*sizeof(data),"ptr");
*/
   free((void *) bptr);
   free((void *) ptr);

   return(0);
}
