/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "agsmrg.h"


void g8mf2(void *x1, void *x2, int n1, int n2, int size, 
           int (*cmp)(const void *,const void *))
{
 register int i,j,l;
 register char *temp;

 register char *s1=(char*) x1 ,*s2=(char *) x2;
 register int M;
 register char *SRC, *DES;

 if ((n1<=0)&&(n2<=0)) return;
 temp = (char *) malloc((n1+n2)*size);
 i=j=l=0;
  for(;((i<n1) && (j<n2));++l){

    if (cmp(s1+i*size, s2+j*size)  > 0){
      MEMCPY(temp+l*size,s2+j*size,size); ++j;
    }
    else {
      MEMCPY(temp+l*size,s1+i*size,size); ++i;
    }
  }
  if (i < n1) MEMCPY( temp+l*size, s1+i*size,(n1-i)*size);
  if (j < n2) MEMCPY( temp+l*size, s2+j*size,(n2-j)*size);
  MEMCPY(s1,temp,n1*size);
  MEMCPY(s2,temp+n1*size,n2*size);
  free((void *)temp);
}

void g8mf3(void *x1, void *x2, int n1, int n2, int size, 
           int (*cmp)(const void *,const void *))
{
 register int i,j,l;
 register char *temp;

 register char *s1=(char*) x1 ,*s2=(char *) x2;
 register int M;
 register char *SRC, *DES;

 if ((n1<=0)&&(n2<=0)) return;
 temp = (char *) malloc((n1+n2)*size);
 i=j=l=0;
  for(;((i<n1) && (j<n2));++l){
    if (cmp(s2+j*size, s1+i*size) < 0){
      MEMCPY(temp+l*size,s2+j*size,size); ++j;
    }
    else {
      MEMCPY(temp+l*size,s1+i*size,size); ++i;
    }
  }
  if (i < n1) MEMCPY( temp+l*size, s1+i*size,(n1-i)*size);
  if (j < n2) MEMCPY( temp+l*size, s2+j*size,(n2-j)*size);
  MEMCPY(s1,temp,n1*size);
  MEMCPY(s2,temp+n1*size,n2*size);
  free((void *)temp);
}

void g8mf3o(void *x1, void *x2, int n1, int n2, int size, 
            int (*cmp)(const void *,const void *))
{
 register int i,j,l;
 register char *temp;
 register int ip,jp,lp;
 register char *s1=(char*)x1,*s2=(char*) x2;
 register int M;
 register char *SRC, *DES;

 if ((n1<=0)&&(n2<=0))return;
 temp = (char *) malloc((n1+n2)*size);
  i=j=l=0; ip=jp=lp=0;
  for(;((i<n1) && (j<n2));++l,lp+=size){
    if (cmp((s2+jp), (s1+ip)) < 0){
      MEMCPY((temp+lp),(s2+jp),size);
      ++j; jp+=size;
    }
    else {
      MEMCPY((temp+lp),(s1+ip),size);
      ++i; ip+=size;
    }
  }
  if (i < n1) MEMCPY((temp+lp),(s1+ip),(n1-i)*size);
  if (j < n2) MEMCPY((temp+lp),(s2+jp),(n2-j)*size);
  MEMCPY(s1,temp,n1*size);
  MEMCPY(s2,temp+n1*size,n2*size);
  free((void *)temp);
}

void g8mf3x(void *x1, void *x2, int n1, int n2, int size, 
            int (*cmp)(const void *,const void *))
{
 register int i,j;
 register char *temp, *t;

 register char *s1=(char*) x1 ,*s2=(char *) x2;
 register int M;
 register char *SRC, *DES;

 if ((n1<=0)&&(n2<=0)) return;
 temp = (char *) malloc((n1+n2)*size);
 t=temp;
 i=j=0;
  for(;((i<n1) && (j<n2));temp+=size){
    if (cmp(s2, s1) <  0){
      MEMCPY(temp,s2,size);
      ++j; s2+=size;
    }
    else {
      MEMCPY(temp,s1,size);
      ++i; s1+=size;
    }
  }
  if (i < n1) MEMCPY(temp,s1,(n1-i)*size);
  if (j < n2) MEMCPY(temp,s2,(n2-j)*size);
  MEMCPY(x1,t,n1*size);
  MEMCPY(x2,t+n1*size,n2*size);
  free((void *)t);
}


void g8mf4(void *x1, void *x2, int n1, int n2,int size,
           int (*cmp)(const void*,const void*))
{
 register int M;
 register char *SRC, *DES;
 register char *temp,*tmp,*first1,*last1,*first2,*last2;
 register char *s1=(char*)x1,*s2=(char*)x2;

 if ((n1<= 0)  && (n2<= 0))  return ;
 tmp = (char *) malloc((n1+n2)*size);
 first1=s1;          first2=s2;
 last1 =s1+n1*size;  last2 =s2+n2*size;
 temp=tmp;

 for (;((first1 != last1) && (first2 != last2));temp+=size)
    if (cmp(first2,first1)<0){
      MEMCPY(temp,first2,size);
      first2+=size;
    }
    else {
      MEMCPY(temp,first1,size);
      first1+=size;
    }
 if ( first1 != last1)
   MEMCPY(temp,first1,(last1-first1));
 if ( first2 != last2)
   MEMCPY(temp,first2,(last2-first2));

  MEMCPY(s1,tmp,n1*size) ;
  MEMCPY(s2,tmp+n1*size,n2*size);
  free((void *)tmp);
}


void g8mf4o(void *x1, void *x2, int n1, int n2,int size,
           int (*cmp)(const void*,const void*))
{
 register int M;
 register char *temp,*tmp,*first1,*last1,*first2,*last2;
 register char *s1=(char*)x1,*s2=(char*)x2;

 if ((n1<= 0)  && (n2<= 0))  return ;
 tmp = (char *) malloc((n1+n2)*size);
 first1=s1;          first2=s2;
 last1 =s1+n1*size;  last2 =s2+n2*size;
 temp=tmp;

 for (;((first1 != last1) && (first2 != last2));temp+=size)
    if (cmp(first2,first1)<0){
      for(s1=temp,s2=first2,M=size;0<M;++s1,++s2,--M)
         *s1=*s2;
      first2+=size;
    }
    else {
      for(s1=temp,s2=first1,M=size;0<M;++s1,++s2,--M)
         *s1=*s2;
      first1+=size;
    }
 if ( first1 != last1)
   for(s1=temp,s2=first1,M=last1-first1;0<M;++s1,++s2,--M)
      *s1=*s2;
 if ( first2 != last2)
   for(s1=temp,s2=first2,M=last2-first2;0<M;++s1,++s2,--M)
      *s1=*s2;
 for(s1= x1,s2=tmp,        M=n1*size;0<M;++s1,++s2,--M) *s1=*s2;
 for(s1= x2,s2=tmp+n1*size,M=n2*size;0<M;++s1,++s2,--M) *s1=*s2;
 free((void *)tmp);
}
