/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/


#include <memory.h>
#include <limits.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "agdata.h"

#ifndef MIN
#define MIN(x,y)  ((x)<=(y)?(x):(y))
#endif

#define GRANDOM(X)  (int)((random()/((double)2147483647.0))*X)
#define GSRANDOM()   srandom((unsigned int)time(NULL))

/* 2019 code definitions start here */
/* BSRTSZE is for merge-sort's insertionsort */
/* for mergesort BSRTSZE to 16 ; for QuickSort NQSSZE to 16    */
/* MRGBSRT: ag21ins, q1ins5, q1ins7                            */
/* INT-DATA : Mergesort 24 and d1ins5, QUICKSORT 32 and d1ins5 */
/* GENERIC  : Mergesort 24 and d1ins7, QUICKSORT 24 and d1ins7 */
/*    INT DATA                   GENERIC
 * #define MRGBSRT  q1ins5       q1ins7
 * #define MRGBSRTD d1ins5       d1ins5 ... does not matter for gnrc
 * #define BSRTSZE  24           16 better than 24. matters in BOTH cases
 *
 * #define NQSIS    q1ins5       q1ins7 ... matters for gnrc
 * #define NQSSZE   24            24 or 32. matters for gnrc
 * #define INQSIS   d1ins5       d1ins5 ... does not matter for gnrc
 * #define INQSSZE  32           in 
 */
#define MRGBSRT  q1ins7  /* from 7 */ 
#define MRGBSRTD d1ins5  /* from 5 */
#define BSRTSZE   24     /* from 24, 8 seems better though*/

#define NQSIS    q1ins7  /* from 7 */ 
#define NQSSZE   24      /* from 24*/
#define INQSIS   d1ins5
#define INQSSZE  32
  
#define STSZ    64
#define FIRST_KEY  0
#define MIDDLE_KEY 1
#define RANDOM_KEY 2
#define SPLITTER  MIDDLE_KEY
/* 2019 code definitions end   here */

#define SWAPP(i1,i2) \
  {ii = size;do {k = *(i1);*(i1)++ = *(i2);*(i2)++ = k;} while(--ii);}
#define SWAPPY(XX,YY,TT,SS) {DES=(XX);SRC=(YY);M=(SS); do {*TT=*DES;*DES++=*SRC;*SRC++=*TT;} while ( --M); }

/*
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#undef MEMCPY
SWAP(char *x, char *y, int    size)
{
  while(size-- > 0) {
    char tmp = *x;
    *x++ = *y;
    *y++ = tmp;
  }
}
MEMCPY(void *x, void *y, int    size)
{
  while(size-- > 0) {
    char *pbTo = (char *)x;
    char *pbFrom = (char *)y;
    *pbTo++ = *pbFrom++;
  }
}
*/
#define MEMCPY(XX,YY,SS) {DES=(XX);SRC=(YY);M=(SS); do {*DES++=*SRC++;} while (--M); }
#define IMEMCPY(XX,YY,SS) {DES=(XX);SRC=(YY);M=(SS); do {*DES++=*SRC++;} while (--M); }

void q0gnu1  (void *,int ,int ,int (*)(const void*,const void*));

void q1ins1 (void *,int ,int ,int (*)(const void*,const void*));
void q1ins2 (void *,int ,int ,int (*)(const void*,const void*));
void q1ins5  (void *,int ,int ,int (*)(const void*,const void*));
void q1ins7  (void *,int ,int ,int (*)(const void*,const void*));
void q1ins8  (void *,int ,int ,int (*)(const void*,const void*));
void q1inb1  (void *,int ,int ,int (*)(const void*,const void*));

void q3mrgiu (void *,int ,int ,int (*)(const void*,const void*));
void q3mrgio (void *,int ,int ,int (*)(const void*,const void*));

void q4mrgi1 (void *,int ,int ,int (*)(const void*,const void*));
void q4mrgi2 (void *,int ,int ,int (*)(const void*,const void*));

void q5hpx1  (void *,int ,int ,int (*)(const void*,const void*));
void q5hpx2  (void *,int ,int ,int (*)(const void*,const void*));
void q5hpx3  (void *,int ,int ,int (*)(const void*,const void*));
void q5hpx4  (void *,int ,int ,int (*)(const void*,const void*));

void q6carh1 (void *,int ,int ,int (*)(const void*,const void*));
void q6carh2 (void *,int ,int ,int (*)(const void*,const void*));
void q6carh3 (void *,int ,int ,int (*)(const void*,const void*));

void q6qkrd1 (void *,int ,int ,int (*)(const void*,const void*));
void q6qkrd2 (void *,int ,int ,int (*)(const void*,const void*));

void q6qkrw1 (void *,int ,int ,int (*)(const void*,const void*));
void q6qkrw2 (void *,int ,int ,int (*)(const void*,const void*));
void q6qkrw3 (void *,int ,int ,int (*)(const void*,const void*));
void q6qkrw4 (void *,int ,int ,int (*)(const void*,const void*));

void q7qknd0 (void *,int ,int ,int (*)(const void*,const void*));
void q7qknd1 (void *,int ,int ,int (*)(const void*,const void*));
void q7qknd2 (void *,int ,int ,int (*)(const void*,const void*));
void q7qknd3 (void *,int ,int ,int (*)(const void*,const void*));
void q7qknd4 (void *,int ,int ,int (*)(const void*,const void*));
void q7qknd5 (void *,int ,int ,int (*)(const void*,const void*));
void q7qknd6 (void *,int ,int ,int (*)(const void*,const void*));
void q7qknd7 (void *,int ,int ,int (*)(const void*,const void*));
