/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/


#include <memory.h>
#include <limits.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "agidata.h"


#ifndef MIN
#define MIN(x,y)  ((x)<=(y)?(x):(y))
#endif

#define GRANDOM(X)  (int)((random()/((double)2147483647.0))*X)
#define GSRANDOM()   srandom((unsigned int)time(NULL))

/* 2019 code definitions start here */
/* BSRTSZE is for merge-sort's insertionsort */
/* for mergesort BSRTSZE to 16 ; for QuickSort NQSSZE to 16    */
/* MRGBSRT: ag21ins, q1ins5, q1ins7                            */
/* INT-DATA : Mergesort 24 and d1ins5, QUICKSORT 32 and d1ins5 */
/* GENERIC  : Mergesort 24 and d1ins7, QUICKSORT 24 and d1ins7 */
/*    INT DATA                   GENERIC
 * #define MRGBSRT  q1ins5       q1ins7
 * #define MRGBSRTD d1ins5       d1ins5 ... does not matter for gnrc
 * #define BSRTSZE  24           16 better than 24. matters in BOTH cases
 *
 * #define NQSIS    q1ins5       q1ins7 ... matters for gnrc
 * #define NQSSZE   24            24 or 32. matters for gnrc
 * #define INQSIS   d1ins5       d1ins5 ... does not matter for gnrc
 * #define INQSSZE  32           in
 */
#define MRGBSRT  q1ins7  /* from 7 */
#define MRGBSRTD i1ins5  /* from 5 */
#define BSRTSZE   24     /* from data:24, 8 , ddata:24 */

#define NQSIS    q1ins7  /* from 7 */
#define NQSSZE   24      /* data: 24*/
#define INQSIS   i1ins5  /* from d1ins5*/
#define INQSSZE  32      /*              ddata:32 */

#define STSZ    64
#define FIRST_KEY  0
#define MIDDLE_KEY 1
#define RANDOM_KEY 2
#define SPLITTER  MIDDLE_KEY
/* 2019 code definitions end   here */

#define SWAPP(i1,i2) \
  {ii = size;do {k = *(i1);*(i1)++ = *(i2);*(i2)++ = k;} while(--ii);}
#define SWAPPY(XX,YY,TT,SS) {DES=(XX);SRC=(YY);M=(SS); do {*TT=*DES;*DES++=*SRC;*SRC++=*TT;} while ( --M); }

/*
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#undef MEMCPY
SWAP(char *x, char *y, int    size)
{
  while(size-- > 0) {
    char tmp = *x;
    *x++ = *y;
    *y++ = tmp;
  }
}
MEMCPY(void *x, void *y, int    size)
{
  while(size-- > 0) {
    char *pbTo = (char *)x;
    char *pbFrom = (char *)y;
    *pbTo++ = *pbFrom++;
  }
}
*/
#define MEMCPY(XX,YY,SS) {DES=(XX);SRC=(YY);M=(SS); do {*DES++=*SRC++;} while (--M); }
#define IMEMCPY(XX,YY,SS) {DES=(XX);SRC=(YY);M=(SS); do {*DES++=*SRC++;} while (--M); }

void i1ins1  (idata   * , int );
void i1ins2  (idata   * , int );
void i1ins3  (idata   * , int );
void i1ins4  (idata   * , int );
void i1ins5  (idata   * , int );
void i4mrgi1 (idata   * , int );
void i5hpx1  (idata   * , int );
void i5hpx3  (idata   * , int );
void i6qkrd1 (idata   * , int );
void i6qkrw1 (idata   * , int );
void i7qknd0 (idata   * , int );
void i7qknd2 (idata   * , int );

void i0gnu   (void *,int ,int ,int (*)(const void*,const void*));
void i9rdx4u (idata   * , int );
void i9rdx4o (idata   * , int );
