/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "agssrtd.h"
 /* Iterative MergeSort with baseline InsertionSort */

void d4mrgi1(ddata   *keys,int n)
{
 register int M;
 register ddata *SRC, *DES;
 register ddata *ktmp;
 register ddata   *S, *D, *T, *kys;
 register int i, j, k, r, t, LB, RB;

 if (n <  2   ) return;
 kys  = keys ;
 ktmp = (ddata   *) malloc(n*sizeof(ddata  ));

 for(t=0; t < n ; t+=BSRTSZE) {
    MRGBSRTD(kys + t, MIN(BSRTSZE, (n-t)));
 }

 S=kys; D=ktmp;
 for(r= BSRTSZE ; r < n ; r = (r<<1)) {
     for(t=0 ; t < n; t += (r<<1)) {
        LB=MIN(t+r, n); RB=MIN(t+(r<<1), n);
        i = t ; j = LB ; k = t;
        while ((i< LB) && (j< RB)) {
           if (S[j] < S[i]) {
              D[k] = S[j];
              ++j; ++k;
           }
           else {
              D[k] = S[i];
              ++i;++k;
           }
         }

         if (i< LB) IMEMCPY((ddata*)(D+k), (ddata*)(S+i), (LB-i)               );
         if (j< RB) IMEMCPY((ddata*)(D+k), (ddata*)(S+j), (RB-j)               );
      }
      T=S; S=D; D=T;
 }

  if (S!=kys) IMEMCPY((ddata*)kys,(ddata*)S,n               );
  free(ktmp);
}


void d4mrgi2(ddata   *keys,int n)
{
 register int M;
 register ddata *SRC, *DES;
 register ddata     *ktmp;
 register ddata   *S, *D, *T, *kys, key;
 register int i, j, k, r, t, LB, RB;

 if (n <  2   ) return;
 kys  = keys ;
 ktmp = (ddata   *) malloc(n*sizeof(ddata  ));

 for(t=0; t < n ; t+=BSRTSZE) {
   /*
    MRGBSRTD(kys + t, MIN(BSRTSZE, (n-t)));
    */
   S=kys+t;
   for(D=S+1; D< S+MIN(BSRTSZE, (n-t)); ++D) {
     key=*D;
     for(SRC=D; (SRC > S) && ( *(SRC-1) > key) ; --SRC) {
         *SRC=*(SRC-1);
     }
     *SRC = key;
   }
 }

 S=kys; D=ktmp;
 for(r= BSRTSZE ; r < n ; r = (r<<1)) {
     for(t=0 ; t < n; t += (r<<1)) {
        LB=MIN(t+r, n); RB=MIN(t+(r<<1), n);
        i = t ; j = LB ; k = t;
        while ((i< LB) && (j< RB)) {
           if (S[j] < S[i]) {
              D[k] = S[j];
              ++j; ++k;
           }
           else {
              D[k] = S[i];
              ++i;++k;
           }
         }

         if (i< LB) IMEMCPY((ddata*)(D+k), (ddata*)(S+i), (LB-i)               );
         if (j< RB) IMEMCPY((ddata*)(D+k), (ddata*)(S+j), (RB-j)               );
      }
      T=S; S=D; D=T;
 }

  if (S!=kys) IMEMCPY((ddata*)kys,(ddata*)S,n               );
  free(ktmp);
}

void d3mrgiu (ddata *akeys,int n)
{
  register int M;
  register ddata *DES,*SRC;
  register ddata *keys= akeys;
  register ddata *temp,*tmp, *s, *t;
  register int  i,j,k,ii,jj,a,b;

  if (n<=1) return;
  temp=(ddata*)malloc(n*sizeof(ddata));

  a=n/BSRTSZE;b=BSRTSZE;
  for(j=0;j<a;j++,keys+=b) {
     MRGBSRTD(keys,BSRTSZE);
  }
  if (a*BSRTSZE < n)
     MRGBSRTD(keys,n-a*BSRTSZE);

  keys=akeys; /* recover original keys */

  s=keys;t=temp;
  for(a=BSRTSZE;a<n;a=(a+a)) {
     for(b=0;b<n;b+=(a+a)) {
         ii=MIN((b+(a+a)),n);jj=MIN((b+a),n);
         i=jj;j=b;k=b;
         while ((i<ii)&&(j<jj)) {
           if (*(s+j) < *(s+i)) {
              *(t+k)=*(s+j);
              ++j; ++k;
           }
           else {
              *(t+k)= *(s+i);
              ++i; ++k;
           }
         }
         if (i<ii) IMEMCPY((t+k),(s+i),(ii-i));
         if (j<jj) IMEMCPY((t+k),(s+j),(jj-j));
     }
     tmp=s;s=t;t=tmp;
  }

  if (s!=keys) IMEMCPY(keys,s,(n));

  free((void *)temp);
}

void d3mrgio (ddata *akeys, int n)
{
  register int M;
  register ddata *DES,*SRC;
  register ddata *keys= (ddata *) akeys;
  register ddata *temp,*tmp, *s, *t,  key;
  register int  i,j,k,ii,jj,a,b;

  if (n<=1) return;
  temp=(ddata *)malloc(n*sizeof(ddata));

  a=n/BSRTSZE;b=BSRTSZE;
  for(j=0;j<a;j++,keys+=b) {
      tmp=keys;
      for(s=tmp+1;s<tmp+b; ++s){
         key  = *s ;
         for(t=s; (t > tmp) && ( *(t-1) > key );--t){
            *t= *(t-1);
         }
         *t = key ;
      }
  }
  if (a*BSRTSZE < n) {
      tmp=keys;
      for(s=tmp+1;s<tmp+(n-a*BSRTSZE);++s){
          key = *s ;
          for(t=s;(t > tmp) && (*(t-1) > key);--t){
             *t= *(t-1);
          }
          *t = key;
      }
  }

  keys=(ddata *) akeys; /* recover original keys */
  s=keys;t=temp;
  for(a=BSRTSZE;a<n;a=(a+a)) {
     for(b=0;b<n;b+=(a+a)) {
         ii=MIN((b+(a+a)),n);jj=MIN((b+a),n);
         i=jj;j=b;k=b;
         while ((i<ii)&&(j<jj)) {
           if (*(s+j) < *(s+i)) {
              *(t+k) = *(s+j);
              ++j; ++k;
           }
           else {
              *(t+k) = *(s+i);
              ++i; ++k;
           }
         }
         if (i<ii) IMEMCPY((t+k),(s+i),(ii-i));
         if (j<jj) IMEMCPY((t+k),(s+j),(jj-j));
     }
     tmp=s;s=t;t=tmp;
  }

  if (s!=keys) IMEMCPY(keys,s,n);

  free((void *)temp);
}

