/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "agssrtd.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif

 /* Integer QuickSort Non-Recursive using do  ; very simple version */
void d6carha(ddata *akeys, int *L,int *R)
{
  register int  l,r,mL,mR;
  register ddata *keys=akeys;
  register ddata split, tmp,*pi,*jp , *ip;


  if ((*R-*L) <= 0) return ; /* if ((*R-*L+1) <= 1) return ; */

   mL=*L;mR=*R;
  while (mL < mR ) {
     l=mL;r=mR;
#if   SPLITTER == MIDDLE_KEY
 split=keys[(l+r)/2];
#elif SPLITTER == FIRST_KEY
 split=keys[l];
#elif SPLITTER == RANDOM_KEY
 split=keys[l+GRANDOM((r-l+1))];
#endif

     while (l <= r) {
         while (keys[l]<split) ++l;
         while (split< keys[r]) --r;
         if (l <= r) { /* is it ok if < ? */
           tmp=keys[l];
           keys[l]=keys[r];
           keys[r]=tmp;
/*
           tmp=*(keys+l);
           *(keys+l)=*(keys+r);
           *(keys+r)=tmp;
*/
           ++l;--r;
         }
     }

   if ((r-mL) < (mR-l)) { /* Left side smaller; eliminated a +1 from both sides */
      if ((r-mL+1) < INQSSZE ) {
                 if ((r-mL) >0) {   /* usedto be r-mL+1 > 1 */
                  pi=keys+mL;
                  for(jp=pi+1; jp< pi+(r-mL+1); ++jp){
                    split=*jp;
                    for(ip=jp; ip >pi && (*(ip-1)>split) ; --ip) {
                      *(ip)=*(ip-1);
                    }
                    *(ip)=split;
                  }
                 }
          mL=l;
      }
      else {
         *R=r; *L=mL; /* mL...r */
         d6carha(keys,L,R);
         mL=l;  /* OR r l ..mR */
      }
   } /*left */
  else {               /* Right side smaller */
      if ((mR-l+1) < INQSSZE ) {
                          if ((mR-l) >0) { /* used to be mR-l+1 >1 */
               pi=keys+l;
                  for(jp=pi+1; jp< pi+(mR-l+1); ++jp){
                    split=*jp;
                    for(ip=jp; ip >pi && (*(ip-1)>split) ; --ip) {
                      *(ip)=*(ip-1);
                    }
                    *(ip)=split;
                  }
                 }
       mR=r;
      }
      else {
        *L=l; *R=mR;  /* l...mR */
        d6carha (keys,L,R);
        mR=r;  /* mL ...r */
      }

  } /*right*/
 }

}

void d6carh (ddata *keys, int n)
{
  int myL,myR;
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  myL=0;myR=n-1;
  d6carha (keys,&myL,&myR);
}



/************************
 * Note : code differs from CLR Hoare code in the following respect
 *  say input 10 9 8 7 5 and splitter is middle key 8
 *  at termination we have say l=1 r=5 in the beginning
 *            6 7  8 9 10
 *              r    l
 *  lest partition is 6 7 and right partion is ? 9 10 or  8 9 10?
 *  if all keys are equal
 *            8 8  8  8 8
 *              r     l   at termination
 *  In the g67.c code which is similar (but original and possibly primitive)
 *  left set is L ... r of size r-L+1   base left set keys[L*size]
 *  righ set is l ... R of size R-l+1 correctly identifies keys[l*size]
 *  if g68 and also by extension in g268 we used (pending before potential changes)
 *  left set is size r+1 and right set of size n-l which does not make much sense.
 */

void i6clrs0a(ddata *keys, int n, unsigned int l, unsigned int r)
{
  register unsigned int  i,j;
  register ddata pr,pm,tmp; /* pl out */

  if (n <= 1) return ;
  /* pl=keys[l]; */
  pr=keys[r];
#if SPLITTER == MIDDLE_KEY
  pm = keys[((l+r)/2 )];
#elif SPLITTER == FIRST_KEY
  pm = keys[l];
#elif SPLITTER == RANDOM_KEY
  pm = keys[(l+GRANDOM((r-l+1)))];
#endif
  tmp=pm;
  pm=pr;
  pr=tmp;
  i=l-1;
  j=l  ;
  for(j=l;j<r;++j) {
    if (keys[j]<=keys[r]) {
       ++i;
       tmp=keys[j];
       keys[j]=keys[i];
       keys[i]=tmp;
    }
  }
  ++i;
  tmp=keys[r];
  keys[r]=keys[i];
  keys[i]=tmp;

  if ((i-l) < INQSSZE  )
     INQSIS(&keys[l],(i-l));
  else
     i6clrs0a(&keys[l],i-l,0,i-l-1);
  if ((r-i) < INQSSZE )
     INQSIS(&keys[(i+1)],(r-i));
   else
     i6clrs0a(&keys[(i+1)],r-i,0,r-i-1);

}

void d6clrs(ddata *keys, int n)
{
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  i6clrs0a(keys,n,(unsigned int) 0,(unsigned int) n-1);
}
