/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "agssrt.h"

void q3mrgiu(void *akeys,int n,int size,int (*compare)(const void*,const void*) )
{
  register int M;
  register char *DES,*SRC;
  register char *keys= (char *) akeys;
  register char *temp,*tmp, *s, *t;
  register int  i,j,k,ii,jj,a,b;

  if (n<=1) return;
  temp=(char *)malloc(n*size*sizeof(char));

  a=n/BSRTSZE;b=BSRTSZE*size;
  for(j=0;j<a;j++,keys+=b) {
     MRGBSRT(keys,BSRTSZE,size,compare);
  }
  if (a*BSRTSZE < n)
   MRGBSRT(keys,n-a*BSRTSZE,size,compare);

  keys=(char *)akeys; 

  s=keys;t=temp;
  for(a=BSRTSZE;a<n;a=(a+a)) { 
     for(b=0;b<n;b+=(a+a)) {
         ii=MIN((b+(a+a)),n)*size;jj=MIN((b+a),n)*size;      
         i=jj;j=b*size;k=j;
         while ((i<ii)&&(j<jj)) {
           if (compare(s+i,s+j)<0) {
              MEMCPY((t+k),(s+i),size);
              i+=size; k+=size;
           }
           else {
              MEMCPY((t+k),(s+j),size);
              j+=size;k+=size;
           }
         }
         if (i<ii) MEMCPY((t+k),(s+i),(ii-i));    
         if (j<jj) MEMCPY((t+k),(s+j),(jj-j));
     }
     tmp=s;s=t;t=tmp;
  }

  if (s!=keys) MEMCPY(keys,s,n*size); 

  free((void *)temp);
}

  /* Optimized (inline insertion sort) version of q3mrgiu */

void q3mrgio (void *akeys,int n,int size,int (*compare)(const void*,const void*) )
{
  register int M;
  register char *DES,*SRC;
  register char *keys= (char *) akeys;
  register char *temp,*tmp, *s, *t;
  register int  i,j,k,ii,jj,a,b;

  if (n<=1) return;
  temp=(char *)malloc(n*size*sizeof(char));

  a=n/BSRTSZE;b=BSRTSZE*size;
  for(j=0;j<a;j++,keys+=b) {
      /* MRGBSRT (keys,BSRTSZE,size,compare); */
      tmp=keys;
      for(s=tmp+size;s<tmp+b          ;s+=size){
        MEMCPY(temp,s,size);
        for(t=s;t > tmp &&(compare(t-size,temp)>0);t-=size){
          MEMCPY((t),(t-size),size);
        }
        MEMCPY((t),temp,size);
      }
  }
  if (a*BSRTSZE < n) {
      /* MRGBSRT (keys,n-a*BSRTSZE,size,compare); */
      tmp=keys;
      for(s=tmp+size;s<tmp+(n-a*BSRTSZE)*size;s+=size){
        MEMCPY(temp,s,size);
        for(t=s;t > tmp &&(compare(t-size,temp)>0);t-=size){
          MEMCPY((t),(t-size),size);
        }
        MEMCPY((t),temp,size);
      }
  }

  keys=(char *) akeys; /* recover original keys */
  s=keys;t=temp;
  for(a=BSRTSZE;a<n;a=(a+a)) { 
     for(b=0;b<n;b+=(a+a)) {
         ii=MIN((b+(a+a)),n)*size;jj=MIN((b+a),n)*size; 
         i=jj;j=b*size;k=b*size; 
         while ((i<ii)&&(j<jj)) {
           if (compare(s+i,s+j)<0) {
              MEMCPY((t+k),(s+i),size);
              i+=size; k+=size;
           }
           else {
              MEMCPY((t+k),(s+j),size);
              j+=size;k+=size;
           }
         }
         if (i<ii) MEMCPY((t+k),(s+i),(ii-i));    
         if (j<jj) MEMCPY((t+k),(s+j),(jj-j));
     }
     tmp=s;s=t;t=tmp;
  }

  if (s!=keys) MEMCPY(keys,s,n*size); 

  free((void *)temp);
}
