/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "agssrt.h"
 /* Iterative MergeSort with baseline InsertionSort */
 /* Optimized versions in q3mrgiu  with inline sort in q3mrgio   */

void q4mrgi1(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{  
 register int M;
 register char *DES, *SRC;
 register char   *kys=(char*) akeys;
 register char *temp, *S, *D, *T;
 register int i, j, k, r, t, LB, RB;

 if (n <  2   ) return;   
 temp = (char *) malloc(n*size*sizeof(char));

 for(t=0; t < n ; t+=BSRTSZE) {
    MRGBSRT(kys + t*size, MIN(BSRTSZE, (n-t)), size, compare);
 }






 S=kys; D=temp;
 for(r= BSRTSZE ; r < n ; r = (r<<1)) {  /* (r<<1) or (r+r) */
     for(t=0 ; t < n; t += (r<<1)) {
        LB=MIN(t+r, n); RB=MIN(t+(r<<1), n); 
        i = t ; j = LB ; k = t;
        while ((i< LB) && (j< RB)) {
           if (compare(S+j*size, S+i*size)< 0) {
              MEMCPY(D+k*size, S+j*size, size);
              ++j; ++k;
           }
           else {
              MEMCPY(D+k*size, S+i*size, size);
              ++i;++k;
           }
         }

         if (i< LB) MEMCPY(D+k*size, S+i*size, (LB-i)*size);  
         if (j< RB) MEMCPY(D+k*size, S+j*size, (RB-j)*size);
      }
      T=S; S=D; D=T;
 }

  if (S!=kys) MEMCPY(kys,S,n*size);
  free(temp);
}


void q4mrgi2 (void *akeys,int n,int size,int (*compare)(const void*,const void*) )
{   
 register int M;
 register char *DES, *SRC;
 register char *kys=(char*) akeys;
 register char *ktmp, *S, *D, *T;
 register int i, j, k, r, t, LB, RB, pi,pj,pk;

 if (n <  2   ) return;
 ktmp = (char *) malloc(n*size*sizeof(char));

 r = BSRTSZE * size;
 for(t=0 , S=kys ; t < n ; t+= BSRTSZE, S += r) {
    MRGBSRT(S, MIN(BSRTSZE, (n-t)), size, compare);
 }

 S=kys; D=ktmp;
 for(r= BSRTSZE ; r < n ; r = (r<<1)) {
     for(t=0 ; t < n; t += (r<<1)) {
        LB=MIN(t+r, n); RB=MIN(t+(r<<1), n);
        i = t ; j = LB ; k = t; pi=i*size; pj=j*size; pk=k*size;
        while ((i< LB) && (j< RB)) {
           if (compare(S+pj, S+pi)< 0) {
              MEMCPY(D+pk, S+pj, size);
              ++j; ++k; pj+=size; pk+=size;
           }
           else {
              MEMCPY(D+pk, S+pi, size);
              ++i;++k;  pi+=size; pk+=size;
           }
         }

         if (i< LB) MEMCPY(D+pk, S+pi, (LB-i)*size);
         if (j< RB) MEMCPY(D+pk, S+pj, (RB-j)*size);
      }
      T=S; S=D; D=T;
 }

  if (S!=kys) MEMCPY(kys,S,n*size);
  free(ktmp);
}

