/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "agssrt.h"
 /*  HeapSort                 */  /* First is g76heapx/g33heapx */

void q5auxx1(void *akeys,  int size, int (*compare) (const void*,const void*), int l, int r)
{  
 register int M,i,j;
 register char *SRC, *DES, *k, *keys=(char*) akeys;

 k    = (char *) malloc(size*sizeof(char));
 i=l; j=i+i+1;
 MEMCPY(k,keys+i*size,size);

 while ( j <= r) {
   if (j < r) {
     if (compare(keys+j*size,keys+j*size+size) < 0) {
       ++j;
     }
   }
   if (compare(k,keys+j*size) >= 0)
        break;

   MEMCPY(keys+i*size,keys+j*size,size);
   i=j;j=i+i+1;
 }
 MEMCPY(keys+i*size,k,size);
 free((void*) k);
}


void q5hpx1(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int l,r,m,c;
 register char  *keys,*pi,*pj;

 if (n <  2 )  return;
 if (size < 1) return;

 keys  = (char *) akeys;
 l = n/2+1;  r= n-1;

 while (l > 0) {
   l--;
   q5auxx1(keys,size,compare,l,r);
 }
 
 while (r > 0) {
   m=size; pi=keys;  pj=keys+r*size;
   do {
    c= *pi;
    *pi++ = *pj;
    *pj++ = c;
   } while (--m);
   r--;
   q5auxx1(keys,size,compare,l,r);
 }

}




/* old avg43 Possibly inspired from  N. Wirth code ? */
void q5auxx2  (void *akeys, int size, int (*compare)(const void*,const void*), int l, int r)
{
 register int M,i,j;
 register char *SRC, *DES;
 register char *k,*keys=(char*) akeys;

 k    = (char *) malloc(size*sizeof(char));

 i=l;j=i+i;
 MEMCPY(k,keys+(i-1)*size,size);

  while(j<=r){
    if ( j < r){
      if (compare(keys+(j-1)*size,keys+j*size)< 0) {   /* 2019: <= became < */
        ++j;
       }
    }
    if (compare(k,keys+(j-1)*size) >=0) break;         /* 2019: test whether > 0 works */

     MEMCPY((keys+(i-1)*size),keys+(j-1)*size,size);
     i=j;j=i+i;
   }
   MEMCPY(keys+(i-1)*size,k,size);
   free((void*)k);
}


void q5hpx2 (void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
  register int l,r,c,M;
  register char *k,*keys=(char*) akeys,*SRC,*DES;

  l = (n>>1)+1; r = n;
    k=(char *)malloc(size*sizeof(char));

  while(l > 1) {
    --l;
    q5auxx2 (keys,size,compare,l,r);
  }
  while (r > 1) {
    M=size; SRC=keys; DES=keys+(r-1)*size;
    do { c=*SRC; *SRC++=*DES; *DES++=c;} while (--M);
/*
    MEMCPY(tmp,keys,size);
    MEMCPY(keys,(keys+(r-1)*size),size);
    MEMCPY((keys+(r-1)*size),tmp,size);
*/
    r--;
    q5auxx2 (keys,size,compare,l,r);
  }
 free((void*)k);
}

/****Copyright (c) 1997-2019 All rights reserved
 ****  C. J. Siniolakis
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission
 ****      notice appear in all copies of the source code, and
 ****      the above copyright notice appear in clearly visible
 ****      form on all supporting documentation and distribution
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#define  Parent(i)   ((i-1)>>1)
#define  Left(i)     ((i<<1)+1)
#define  Right(i)    ((i<<1)+2)


void Heapify (char *akeys,int n,int i,char *tmp,int size,int (*compare)(const void * , const void *))
{
  register int l,r,t,M;
  char *SRC,*DES;

  l = Left(i);
  r = Right(i);

  if ((l<n) && (compare(&akeys[l*size],&akeys[i*size])>0))
    t=l;
  else
    t=i;
  if ((r<n) && (compare(&akeys[r*size], &akeys[t*size])>0))
    t=r;
  if (t!=i) {
    MEMCPY(tmp,&akeys[i*size],size);
    MEMCPY(&akeys[i*size],&akeys[t*size],size);
    MEMCPY(&akeys[t*size],tmp,size);
    Heapify(akeys,n,t,tmp,size,compare);
  }
}

void Build_Heap (char *akeys,int n,int size,int (*compare)(const void *,const void*))
{
  char *tmp;
  register int i;

  tmp=(char*)malloc(size*sizeof(char));
  for(i=n-1;i>=0;i--) {
      Heapify(akeys,n,i,tmp,size,compare);
  }
  free((void*)tmp);
}

void q5hpx3(void *akeys,int n,int size,int (*compare) (const void*,const void*))
{
 char   *x,*keys,*SRC,*DES;
 register int i,M;

 keys=(char *)akeys;
 x=(char *) malloc(size*sizeof(char));
 Build_Heap(keys,n,size,compare);
 for (i = n-1;i>=1;--i){
      MEMCPY(x,keys,size);
      MEMCPY(keys,&keys[i*size],size);
      MEMCPY(&keys[i*size],x,size);
      Heapify(keys,i,0,x,size,compare);
  }
  free((void*)x);
}


void  ag43hxs(void *akeys,int size,int (*compare)(const void*,const void*),int l,int r)
{
  register int i,j,M;
  register char	*tmp,*keys=(char*) akeys,*SRC,*DES;

  tmp=(char *)malloc(size*sizeof(char));
  i=l;j=i+i;
  MEMCPY(tmp, keys+(i-1)*size,size);

  while(j<=r){
    if (j<r){
      if (compare( keys+(j-1)*size , keys+j*size)<0) {
	++j;
       }
    }
    if (compare(tmp,keys+(j-1)*size )>=0) break;

     MEMCPY( keys+(i-1)*size , keys+(j-1)*size ,size);
     i=j;j=i+i;
   }
   MEMCPY(keys+(i-1)*size ,tmp,size);
  free((void*)tmp);
}
	

void  q5hpx4(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
  register int l,r,M;
  register char*tmp,*keys=(char*) akeys,*SRC,*DES;

  l=(n>>1)+1;r=n;
  tmp=(char *)malloc(size*sizeof(char));

  while(l>1) {
    --l;
    ag43hxs(keys,size,compare,l,r);
  }
  while (r > 1) {
    MEMCPY(tmp,keys,size);
    MEMCPY(keys,keys+(r-1)*size,size);
    MEMCPY( keys+(r-1)*size,tmp,size);
    r--;
    ag43hxs(keys,size,compare,l,r);
  }
  free((void*)tmp);
}
