/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "agssrt.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif

 /* QuickSort Non-Recursive using do  ; memhp  x,y; simplest version */
 /* note : names used to be  none 0, 1, ... 4 5 4  etc */
 /* note : names are              0, ... , 7           */
void q7qknd0(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
  register int i,j,l,r,s;
  register char  *x,*y,*keys=(char*) akeys;
  int   lstack[STSZ];
  int   rstack[STSZ];

  x = (char *) malloc(size*sizeof(char));
  y = (char *) malloc(size*sizeof(char));
  s=0;
  lstack[0]=0;rstack[0]=n-1;
  do {
        l=lstack[s]; r=rstack[s]; --s;
        do {
                i=l;
                j=r;
                memcpy(x,&keys[((l+r)/2)*size],size);

                do {
                        while (compare(&keys[i*size],x) < 0) ++i;
                        while (compare(x,&keys[j*size]) < 0) --j;

                        if (i <= j )
                        {
                                memcpy(y,&keys[i*size],size);
                                memcpy(&keys[i*size],&keys[j*size],size);
                                memcpy(&keys[j*size],y,size);
                                ++i;
                                --j;
                        }
                } while (i <= j);

                if (i < r)
                {
                        ++s; lstack[s]=i; rstack[s]=r;
                } 
                r=j;


        } while ( l < r);

  } while (s>= 0);
 free((void *)x); free((void *)y);

}

 /* QuickSort Non-Recursive using do  ; memhp  x,y; second simplest version */

void q7qknd1 (void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int  M;
 register char *SRC, *DES;
 register char *keys=(char*) akeys;
 register int  i,j,l,r,s;
 register char *x, *y;
 int           lstack[STSZ];
 int           rstack[STSZ];

  keys = (char *) akeys;
  x = (char *) malloc(size*sizeof(char));
  y = (char *) malloc(size*sizeof(char));
  s=0;
  lstack[0]=0;rstack[0]=n-1;
do {
    l=lstack[s]; r=rstack[s]; --s;
    do {
        i=l;
        j=r;
        MEMCPY(x,keys+((l+r)/2)*size,size);

        do {
          while (compare(&keys[i*size],x) < 0) ++i;
          while (compare(x,&keys[j*size]) < 0) --j;

          if (i <= j ) {
            MEMCPY(y,keys+i*size,size);
            MEMCPY(keys+i*size,keys+j*size,size);
            MEMCPY(keys+j*size,y,size);
            ++i;--j;
           }
        } while (i <= j);

        if (i < r) {
          if ((r-i) <NQSSZE  )
            NQSIS (&keys[i*size],(r-i+1),size,compare);
          else {
            ++s; lstack[s]=i; rstack[s]=r;
          }
        }
        r=j;
      } while ( l < r);

   } while (s>= 0);

 free((void *)x); free((void *)y);
}


 /* QuickSort Non-Recursive using do  ; memhp  x,y; simple version */

void q7qknd2 (void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int M;
 register char *SRC, *DES;
 register int i,j,l,r,s,is,js;
 char   *x,*y, *keys;
 static int     lstack[STSZ];
 static int     rstack[STSZ];

  keys = (char *) akeys;
  x = (char *) malloc(size*sizeof(char));
  y = (char *) malloc(size*sizeof(char));
  s=0;
  lstack[0]=0;rstack[0]=n-1;
do {
    l=lstack[s]; r=rstack[s]; --s;
    do {
        i=l; is = i*size;
        j=r; js = j*size;
        MEMCPY(x,&keys[((l+r)>>1)*size],size);
        do {
          while (compare(&keys[i*size],x) < 0) {++i;is+=size;}
          while (compare(x,&keys[j*size]) < 0) {--j;js-=size;}

          if (i <= j ) {
            MEMCPY(y,&keys[is],size);
            MEMCPY(&keys[is],&keys[js],size);
            MEMCPY(&keys[js],y,size);
            ++i; is +=size; --j; js -=size;
           }
        } while (i <= j);

        if (i < r) {
          if ((r-i) <NQSSZE  )
            NQSIS (&keys[is],(r-i+1),size,compare);
          else {
            ++s; lstack[s]=i; rstack[s]=r;
          }
        }
        r=j;
      } while ( l < r);

   } while (s>= 0);
 free((void *)x); free((void *)y);
}

 /* QuickSort Non-Recursive using do  ; local  x,y; simple version */

void q7qknd3 (void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int i,j,l,r,s,is,js;
/* char   *x,*y, *keys; */
 char *keys;
 char x[64],y[64];
 static int     lstack[STSZ];
 static int     rstack[STSZ];

  keys = (char *) akeys;
/* x = (char *) malloc(size*sizeof(char));
   y = (char *) malloc(size*sizeof(char)); */
  s=0;
  lstack[0]=0;rstack[0]=n-1;
do {
    l=lstack[s]; r=rstack[s]; --s;
    do {
        i=l; is = i*size;
        j=r; js = j*size;
        memcpy(x,&keys[((l+r)>>1)*size],size);
        do {
          while (compare(&keys[i*size],x) < 0) {++i;is+=size;}
          while (compare(x,&keys[j*size]) < 0) {--j;js-=size;}

          if (i <= j ) {
            memcpy(y,&keys[is],size);
            memcpy(&keys[is],&keys[js],size);
            memcpy(&keys[js],y,size);
            ++i; is +=size; --j; js -=size;
           }
        } while (i <= j);

        if (i < r) {
          if ((r-i) < NQSSZE )
            NQSIS (&keys[is],(r-i+1),size,compare);
          else {
            ++s; lstack[s]=i; rstack[s]=r;
          }
        }
        r=j;
      } while ( l < r);

   } while (s>= 0);
/*
 free((void *)x); free((void *)y);
*/
}

 char* med50(char *a, char *b, char *c, int (*cmp)(const void *, const void *)) {
       return cmp(a, b) < 0 ?  (cmp(b, c) < 0 ? b : (cmp(a, c) < 0 ? c : a ))
                            :  (cmp(b, c) > 0 ? b : (cmp(a, c) < 0 ? a : c ));
 }


 /* QuickSort Non-Recursive using do  ; inline memcpy ; memhp  x; simple version */

void q7qknd5 (void *akeys, int n, int size, int (*compare) (const void*,const void*))
{ 
 register int M;
 register char *SRC, *DES;
 register int  i,j,l,r,s,m,c;
 register char *x,*keys;
 register char *pi,*pj,*t, *pm;
 static   int  lstack[STSZ];
 static   int  rstack[STSZ];

  keys = (char *) akeys;
  x = (char *) malloc(size*sizeof(char));
  s=0;
  lstack[0]=0;rstack[0]=n-1;
do {
    l=lstack[s]; r=rstack[s]; --s;
    do {
        i=l;
        j=r;
/*        MEMCPY(x,(keys+((l+r)/2)*size),size); */
if (n< 10) {
        MEMCPY(x,(keys + ((l+r)>>1)*size),size);
}
else {
       pi= keys+i*size; pj=keys+j*size; t=keys+((i+j)>>1)*size;
       pm = med50(pi,pj,t,compare);
       MEMCPY(x,pm,size);
}
        pi= keys+i*size;
        pj= keys+j*size;
        do {
          while (compare(pi,x) < 0) {++i;pi+=size;}
          while (compare(x,pj) < 0) {--j;pj-=size;}

          if (i <= j ) {
            m=size;
            do {
             c= *pi;
             *pi++ = *pj;
             *pj++ = c;
            } while (--m);

            ++i; pj -=size;
            --j; pj -=size;
           }
        } while (i <= j);

        if (i < r) {
          if ((r-i) <NQSSZE  )
            NQSIS (pi,(r-i+1),size,compare);
          else {
            ++s; lstack[s]=i; rstack[s]=r;
          }
        }
        r=j;
      } while ( l < r);

   } while (s>= 0);
 free((void *)x);
}




 /* QuickSort Non-Recursive using do  ; inline memcpy ; static x; simple version */

void q7qknd6 (void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int M;
 register char *SRC, *DES;
 register int  i,j,l,r,s,m,c;
 static   char X[64];
 register char *keys;
 register char *x,*pi,*pj;
 static   int  lstack[STSZ];
 static   int  rstack[STSZ];

  keys = (char *) akeys;
  x=X;
  s=0;
  lstack[0]=0;rstack[0]=n-1;
do {
    l=lstack[s]; r=rstack[s]; --s;
    do {
        i=l;
        j=r;
        MEMCPY(x,(keys + ((l+r)>>1)*size),size);
        pi= keys+i*size;
        pj= keys+j*size;
        do {
          while (compare(pi,x) < 0) {++i;pi+=size;}
          while (compare(x,pj) < 0) {--j;pj-=size;}

          if (i <= j ) {
            m=size;
            do {
             c= *pi;
             *pi++ = *pj;
             *pj++ = c;
            } while (--m);
            ++i; pj -=size;
            --j; pj -=size;
           }
        } while (i <= j);

        if (i < r) {
          if ((r-i) < NQSSZE )
            NQSIS (pi,(r-i+1),size,compare);
          else {
            ++s; lstack[s]=i; rstack[s]=r;
          }
        }
        r=j;
      } while ( l < r);

   } while (s>= 0);
}


 /* QuickSort Non-Recursive using do  ; inline memcpy ; memhp  x; simple version */

void q7qknd7 (void *akeys, int n, int size, int (*compare) (const void*,const void*))
{ 
 register int M;
 register char *SRC, *DES;
 register char *keys=(char*) akeys;
 register int  i,j,l,r,s,c,I,J;
 register char *split,*t,*pm;
 register char *pi,*pj;
 static   int  lstack[STSZ];
 static   int  rstack[STSZ];

 if (n<=1) return;
 split = (char *) malloc(size*sizeof(char));
 s=0;
 lstack[0]=0;rstack[0]=n-1;
 do {
    l=lstack[s]; r=rstack[s]; --s;
    do {
        i=l;
        j=r;
/*       MEMCPY(split,(keys+((l+r)/2)*size),size); */
/*        MEMCPY(x,(keys+((l+r)/2)*size),size); */
if (n< 5) {
        MEMCPY(split,(keys + ((l+r)>>1)*size),size);
}
else {
       pi= keys+i*size; pj=keys+j*size; t=keys+((i+j)>>1)*size;
       pm = med50(pi,pj,t,compare);
       MEMCPY(split,pm,size);
}
        pi= keys+i*size; pj= keys+j*size;
        do {
          while (compare(pi,split) < 0) {++i;pi+=size;}
          while (compare(split,pj) < 0) {--j;pj-=size;}

          if (i <= j ) {
            M=size;
            do {
             c= *pi; *pi++ = *pj; *pj++ = c;
            } while (--M);
            ++i; pj -=size;
            --j; pj -=size;
           }
        } while (i <= j);

        if (i < r) {
          if ((r-i) < NQSSZE ) {
            if ((r-i) >0) {
               for(J=1;J<(r-i+1);J++){
                 MEMCPY(split,(pi+J*size),size);
                 I=J-1;pj=pi+I*size;
                 while ((I>=0) && (compare(pj,split)>0) ) {
                  MEMCPY((pj+size),(pj),size);
                  I--;pj-=size;
                 }
                 MEMCPY((pj+size),split,size);
            }
           }
          }
          else {
            s++; lstack[s]=i; rstack[s]=r;
          }
        }
        r=j;
      } while ( l < r);

   } while (s>= 0);
 free((void *)split);
}

