/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "agssrti.h"
 /* Iterative MergeSort with baseline InsertionSort */

void i4mrgi1(idata  *keys,int n)
{
#ifndef IMEMCPY
 register int M;
 register char *SRC, *DES;
#else
 register int   M;
 register idata  *SRC, *DES;
#endif
 register idata *S, *D, *T, *kys;
 idata      *ktmp;
 register int   i, j, k, r, t, LB, RB;

 if (n <  2   ) return;
 kys  = keys ;
 ktmp = (idata  *) malloc(n*sizeof(idata ));

 for(t=0; t < n ; t+=BSRTSZE) {
    MRGBSRTD(kys + t, MIN(BSRTSZE, (n-t)));  /* D from I */
 }

 S=kys; D=ktmp;
 for(r= BSRTSZE ; r < n ; r = (r<<1)) {
     for(t=0 ; t < n; t += (r<<1)) {
        LB=MIN(t+r, n); RB=MIN(t+(r<<1), n);
        i = t ; j = LB ; k = t;
        while ((i< LB) && (j< RB)) {
           if (S[j] < S[i]) {
              D[k] = S[j];
              ++j; ++k;
           }
           else {
              D[k] = S[i];
              ++i;++k;
           }
         }

#ifndef IMEMCPY
         if (i< LB)  MEMCPY((char*)(D+k), (char*)(S+i), (LB-i)*sizeof(idata ));
         if (j< RB)  MEMCPY((char*)(D+k), (char*)(S+j), (RB-j)*sizeof(idata ));
#else
         if (i< LB) IMEMCPY(       (D+k),        (S+i), (LB-i)               );
         if (j< RB) IMEMCPY(       (D+k),        (S+j), (RB-j)               );
#endif
      }
      T=S; S=D; D=T;
 }

#ifndef IMEMCPY
  if (S!=kys)  MEMCPY((char*)kys,(char*)S,n*sizeof(idata ));
#else
  if (S!=kys) IMEMCPY(       kys,       S,n               );
#endif
  free(ktmp);
}

/* Potential Improvement MEMCPY replaced by IMEMCPY that copies integers then
 * sizeof(idata) removed in three instances
 */

/* IMEMCPY changes not propagated to d... or f.... */
