/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "agssrti.h"
 /* Radix Sort                */
/* Watch out if data is signed integer type !!!!  */
void i9rdx4u(idata         *src,int n)
{
  register idata         *des;
  int   cnt[256];
  register int          i,r=256;
  register int          j,idx;
  
  if (n <= 1) return;
  des= (idata         *) malloc(n*sizeof(idata        ));
  memset(cnt,0,r*sizeof(idata)); 
  for (j=0;j<n;++j) cnt[src[j] & 0x000000FF]++; 
  for (i=1;i<r;++i) cnt[i] += cnt[i-1];
  for (j=n-1;j>=0;--j) {
      idx= --cnt[src[j] & 0x000000FF]; 
      des[idx]=src[j];
  }

  r = 256;
  memset(cnt,0,r*sizeof(idata)); 
  for (j=0;j<n;++j)  cnt[(des[j] >> 8) & 0x000000FF ]++;
  for (i=1;i<r;++i) cnt[i] += cnt[i-1];
  for (j=n-1;j>=0;--j) {
      idx = --cnt[(des[j] >> 8) &  0x000000FF];
      src[idx] = des[j];
  }

  r = 256;
  memset(cnt,0,r*sizeof(idata)); 
  for (j=0;j<n;++j)  cnt[(src[j] >> 16) & 0x000000FF ]++;
  for (i=1;i<r;++i) cnt[i] += cnt[i-1];
  for (j=n-1;j>=0;--j) {
      idx = --cnt[(src[j] >> 16) & 0x000000FF ];
      des[idx] = src[j];
  }

  r = 256;
  memset(cnt,0,r*sizeof(idata)); 
  for (j=0;j<n;++j)  cnt[des[j] >> 24]++;
  for (i=1;i<r;++i) cnt[i] += cnt[i-1];
  for (j=n-1;j>=0;--j) {
      idx = --cnt[des[j] >> 24];
      src[idx] = des[j];
  }

  free((void *)des);
}

void i9rdx4o(idata         *src,int n)
{
  register idata         *beg, *end, *jp,*des;
  register int          i,k;
  int   cnt[256];
  
  if (n <= 1) return;
  des= (idata         *) malloc(n*sizeof(idata        ));


  memset(cnt,0,256*sizeof(idata)); 
  beg = src ;
  end = src+n;
  for (jp=beg;jp<end;++jp) (*(cnt+ (*jp & 0x000000FF)))++; 
  for (i=1;i<256;++i) cnt[i] += cnt[i-1];
  for (jp=end-1;jp>= beg ;--jp) {
      k  = -- *(cnt+( *jp & 0x000000FF)); 
      *(des+k)= *jp;
  }

  memset(cnt,0,256*sizeof(idata)); 
  beg=des;
  end=des+n;
  for (jp=beg;jp<end;++jp) (*(cnt+ ((*jp>>8) & 0x000000FF)))++; 
  for (i=1;i<256;++i) cnt[i] += cnt[i-1];
  for (jp=end-1;jp>= beg ;--jp) {
      k  = -- *(cnt+( (*jp>>8) & 0x000000FF)); 
      *(src+k)= *jp;
  }

  memset(cnt,0,256*sizeof(idata)); 
  beg = src ;
  end = src+n;
  for (jp=beg;jp<end;++jp) (*(cnt+ ((*jp>>16) & 0x000000FF)))++; 
  for (i=1;i<256;++i) cnt[i] += cnt[i-1];
  for (jp=end-1;jp>= beg ;--jp) {
      k  = -- *(cnt+( (*jp>>16) & 0x000000FF)); 
      *(des+k)= *jp;
  }

  memset(cnt,0,256*sizeof(idata)); 
  beg=des;
  end=des+n;
  for (jp=beg;jp<end;++jp) (*(cnt+ ((*jp>>24) & 0x000000FF)))++; 
  for (i=1;i<256;++i) cnt[i] += cnt[i-1];
  for (jp=end-1;jp>= beg ;--jp) {
      k  = -- *(cnt+( (*jp>>24) & 0x000000FF)); 
      *(src+k)= *jp;
  }


  free((void *)des);
}

