/****Copyright (c) 1997-2004 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "ssrt.h"
/* Similar to g42 and g43*/

void bg44qsrtm(void *akeys, int n, int size, int (*compare) (const void*,const void*),int l,int r)
{
 register int i,j;
 char	*x,*y,*keys;

 keys = (char *) akeys;
 i=l;j=r;
 x = (char *) malloc(size*sizeof(char));
 y = (char *) malloc(size*sizeof(char));
 memcpy(x,&keys[((l+r)/2)*size],size);

 do {
   while (compare(&keys[i*size],x) < 0) ++i;
   while (compare(x,&keys[j*size]) < 0) --j;
   if (i <= j ) {
     memcpy(y,&keys[i*size],size);
     memcpy(&keys[i*size],&keys[j*size],size);
     memcpy(&keys[j*size],y,size);
     ++i;--j;
   }
 } while (i <= j);
	
 if (l < j) {
   if ((j-l) < THRES16)
     BASES  (&keys[l*size],(j-l+1),size,compare);
 }
 else
     bg44qsrtm(keys,n,size,compare,l,j);

  if (i < r)  {
    if ((r-i) < THRES16)
      BASES  (&keys[i*size],(r-i+1),size,compare);
  }
  else 
      bg44qsrtm(keys,n,size,compare,i,r);
	
 free((void *)x); free((void *)y);
}

void bg44qsrt(void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  bg44qsrtm(keys,n,size,compare,0,n-1);
}
