/****Copyright (c) 1997-2004 All rights reserved
 ****A. V. Gerbessiotis and C. J. Siniolakis
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "ssrt.h"
 /* UPdate of g45: midkey for splitter plus pointer optimizations */

void bg47qsrtl(void *akeys, int   n,int size,int (*compare)(const void*,const void*))
{
  register int  l, r;
  register char *x,*y,*pl,*pr;
  char *keys;

  if (n <= 1) return ;
  l=0;r=n-1;
  keys=(char *) akeys;
  x   = (char *) malloc(size*sizeof(char));
  y   = (char *) malloc(size*sizeof(char));
  pl=&keys[l*size];
  pr=&keys[r*size];

/*
  memcpy(mid,&keys[0],size);
*/
  memcpy(x,&keys[((l+r)>>1)*size],size);

  while (l <= r) {
      while (compare(pl,x)<0) {l++;pl +=size;}
      while (compare(x,pr)<0) {r--;pr -=size;}
      if (l <= r) {
	  memcpy(y,pl,size);
	  memcpy(pl,pr,size);
	  memcpy(pr,y,size);
          l++;r--;pl += size; pr -= size;
      }
  }
  
  if (r > 0) {
      if ((r + 1) < THRES16) BASES (keys, r + 1,size,compare) ;
      else bg47qsrtl(keys, r + 1,size,compare) ;
  }
  if (l < n) {
      if ((n - l) < THRES16) BASES (&keys[l*size], n - l,size,compare) ;
      else bg47qsrtl(&keys[l*size], n - l,size,compare) ;
  }
 free((void *)x); free((void *)y);
}
           
void bg47qsrt(void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
  bg47qsrtl(keys,n,size,compare);
}

