/****Copyright (c) 1997-2004 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "ssrt.h"
 /* CLRS version */

void bg48qsrtm(void *akeys, int   n,int size,int (*compare)(const void*,const void*),int l,int r)
{
  register int  i,j;
  register char *x,*pi,*pj,*pm,*pl,*pr;
  char *keys;

  if (n <= 1) return ;
  keys=(char *) akeys;
  x = (char *) malloc(size*sizeof(char));
  pl= keys+l*size;
  pr= keys+r*size;
  pm= &keys[((l+r)/2)*size];
  memcpy(x,pm,size);
  memcpy(pm,pr,size);
  memcpy(pr,x,size);
  i=l-1; pi=pl-size;
  j=l  ; pj=pl; 
  for(j=l;j<r;j++,pj+=size) {
    if (compare(pj,pr) <=0) {
       i++;pi+=size;
       memcpy(x ,pj,size);
       memcpy(pj,pi,size);
       memcpy(pi,x ,size);
       
    }
  }
  pi+=size;
  i++;
  memcpy(x ,pr,size);
  memcpy(pr,pi,size);
  memcpy(pi,x ,size);

  if ((i-l) < THRES16)
     BASES(&keys[l*size],(i-l),size,compare);
  else
     bg48qsrtm(keys,n,size,compare,l,i-1);
  if ((r-i) < THRES16)
     BASES(&keys[(i+1)*size],(r-i),size,compare);
   else
     bg48qsrtm(keys,n,size,compare,i+1,r);

 free((void *)x); 
}
           
void bg48qsrt(void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
  bg48qsrtm(keys,n,size,compare,0,n-1);
}

