/****Copyright (c) 1997-2004 All rights reserved
 ****A. V. Gerbessiotis and C. J. Siniolakis
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "ssrt.h"

void cg30mrgit(void *akeys,int n,int size,int (*compare)(const void*,const void*) )
{
 char *DES,*SRC;
 register int M;
 char *temp,*keys,*tmp, *s, *t;
 register int  i,j,l,d,phase,q,r;

 if ((n<=1) ||(size<=0)) return;
 keys = (char *) akeys;
 temp= (char *) malloc(n*size*sizeof(char));
#ifdef SANITY_CHECK
 check_if_null(temp,"g30mrgit","temp");
#endif
  for(d=0;d<n;d+=TMERGE) {
      BASES (&keys[d*size],MIN(TMERGE,(n-d)),size,compare);
  }
  s=keys;t=temp;
  for(phase =TMERGE;phase<n;phase=Times2(phase)) { 
      for (d=0;d<n;d+=Times2(phase)) {
         q=MIN(d+Times2(phase),n);r=MIN(d+phase,n);
         i=r;j=d;l=d;  
         while ((i<q)&&(j<r)) {
           if (compare(&s[i*size],&s[j*size])<0) {
              MEMCPY(&t[l*size],&s[i*size],size);
              i++; l++; 
           }
           else {
              MEMCPY(&t[l*size],&s[j*size],size);
              j++;l++;
           }
         }

         if (i<q) MEMCPY(&t[l*size],&s[i*size],(q-i)*size);    
         if (j<r) MEMCPY(&t[l*size],&s[j*size],(r-j)*size);
        }
      tmp=s;s=t;t=tmp;
    }

  if (s!=keys) MEMCPY(keys,s,n*size); 

  free((void *)temp);
}
