/****Copyright (c) 1997-2004 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "ssrt.h"
/* This is CAR Hoare as it appears on Cormen page 160*/

void ag170my3  (void *akeys, int n, int size, int (*compare) (const void*,const void*),int l,int r)
{
 register char *split,*tmp, *pl,*pr,*pi,*pj;
 register int i,j,M,c,I,J,Z;
 char *keys,*DES,*SRC;

 if (l>=r) return;

 keys = (char *) akeys;
 tmp  = (char *) malloc(size*sizeof(char));
 split= (char *) malloc(size*sizeof(char));
#ifdef SANITY_CHECK
  check_if_null(split,"g170my3","split");
  check_if_null(tmp  ,"g170my3",  "tmp  ");
#endif

#if SPLITTER == MIDDLE_KEY
 MEMCPY(split,&keys[((l+r)>>1)*size],size);
#elif SPLITTER == FIRST_KEY
 MEMCPY(split,&keys[l*size],size);
#elif SPLITTER == RANDOM_KEY
 MEMCPY(split,&keys[(l+GRANDOM((r-l+1)))*size],size);
#endif
 i=l-1; j=r+1;
 pl=&keys[i*size];
 pr=&keys[j*size];

 while (1) {
   do {j--; pr -=size;}
   while (compare(pr,split) > 0) ;
   do {i++; pl +=size; }
   while (compare(pl,split) < 0) ;
   if (i<j)  {
/*
     MEMCPY(tmp,pl,size);
     MEMCPY(pl,pr,size);
     MEMCPY(pr,tmp,size);
*/
               M=size;
          do {
            c= *pl; *pl++ = *pr ; *pr++=c;
            } while (--M);
		pl-=size;pr-=size;
   }
   else  break;

 }
   Z=j;
   if ((Z-l+1) < THRES16) {
            if ((Z-l+1) >1) {
               pi=&keys[l*size];
               for(J=1;J<(Z-l+1);J++){
                 MEMCPY(split,(pi+J*size),size);
                 I=J-1;pj=pi+I*size;
                 while ((I>=0) && (compare(pj,split)>0) ) {
                  MEMCPY((pj+size),(pj),size);
                  I--;pj-=size;
                 }
                 MEMCPY((pj+size),split,size);
            }
           }

   }
   else {
           ag170my3(akeys,n,size,compare,l,Z);
   }

   if ((r-Z  ) < THRES16) {
            if ((r-Z) >1) {
               pi=&keys[(Z+1)*size];
               for(J=1;J<(r-Z);J++){
                 MEMCPY(split,(pi+J*size),size);
                 I=J-1;pj=pi+I*size;
                 while ((I>=0) && (compare(pj,split)>0) ) {
                  MEMCPY((pj+size),(pj),size);
                  I--;pj-=size;
                 }
                 MEMCPY((pj+size),split,size);
            }
           }
   }
   else {
           ag170my3(akeys,n,size,compare,Z+1,r);
   }

}

void g170my3  (void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
  ag170my3  (keys,n,size,compare,0,n-1);
}
