/****Copyright (c) 1997-2004 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "ssrt.h"

void A253fbc(void *akeys, int   n,int size,int (*compare)(const void*,const void*),int *L,int *R)
{
  register int  i,j,M,c,I,J,l,r,q;
  register char *tmp,*pi,*pj,*pm,*pr,*pl,*split;
  char *keys,*DES,*SRC;

  if (n <= 1) return ;

     keys=(char *) akeys;
     tmp = (char *) malloc(size*sizeof(char));
     split= (char *) malloc(size*sizeof(char));
#ifdef SANITY_CHECK
     check_if_null(tmp  ,"g253fbc","tmp ");
     check_if_null(split  ,"g253fbc","split ");
#endif

  l=*L;r=*R;
  while (l < r) {
#if SPLITTER == MIDDLE_KEY
     pm = &keys[((l+r)>>1)*size];
#elif SPLITTER == FIRST_KEY
     pm = &keys[l*size];
#elif SPLITTER == RANDOM_KEY
     pm = &keys[(l+GRANDOM((r-l+1)))*size];
#endif
     pr=keys+r*size;
     pl=keys+l*size;
     MEMCPY(split,pm,size);
     MEMCPY(pm,pr,size);
     MEMCPY(pr,split,size);
     i=l-1; pi=pl-size; pj=pl;
     for(j=l;j<r;j++,pj+=size) {
        if (compare(pj,split) <=0) {
           i++; pi+=size;
/*
           MEMCPY(tmp,keys+j*size,size);
           MEMCPY(keys+j*size,keys+i*size,size);
           MEMCPY(keys+i*size,tmp,size);
*/
           M=size; 
           do {
              c= *pi; *pi++ = *pj ; *pj++=c;
           } while (--M);
           pi-=size;pj-=size;
        }
    }
    i++;
    MEMCPY(tmp ,keys+r*size,size);
    MEMCPY(keys+r*size,keys+i*size,size);
    MEMCPY(keys+i*size,tmp,size);

    q=i;

    if ((q-l) < (r-q)) {                  /* Question or Bug: is left set q-l as it currently*/
       if ((q-l)< THRES16) {              /*  is or q-l+1 */
                 if ((q-l) >1) {
                  pi=&keys[l*size];
                  for(J=1;J<(q-l  );J++){
                    MEMCPY(split,(pi+J*size),size);
                    I=J-1;pj=pi+I*size;
                    while ((I>=0) && (compare(pj,split)>0) ) {
                     MEMCPY((pj+size),(pj),size);
                     I--;pj-=size;
                    }
                    MEMCPY((pj+size),split,size);
                  }
                 }

        l=q+1;
       }
       else{
	  *L=l; *R=q-1;  /* q-1 --> q , q-l ---> q-l+1 if Question above is valid  */
          A253fbc(keys,q-l,size,compare,L,R);
          l=q+1; /* no change */
       }
    }
    else {
      if ((r-q) < THRES16) {
                 if ((r-q) >1) {
               pi=&keys[(q+1)*size];
               for(J=1;J<(r-q  );J++){
                 MEMCPY(split,(pi+J*size),size);
                 I=J-1;pj=pi+I*size;
                 while ((I>=0) && (compare(pj,split)>0) ) {
                  MEMCPY((pj+size),(pj),size);
                  I--;pj-=size;
                 }
                 MEMCPY((pj+size),split,size);
            }
           }

       r=q-1;
      }
      else {
           *L=q+1;*R=r;
           A253fbc(keys,r-q,size,compare,L,R);
           r=q-1;
      }
    }

  } /* Outer while loop */



 free((void *)tmp); 
 free((void *)split);
}
           
void g253fbc (void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  int myL,myR;
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  myL=0; myR=n-1;
  A253fbc(keys,n,size,compare,&myL,&myR);
}

