/****Copyright (c) 1997-2011 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "ssrt.h"

void g55non1(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int i,j,l,r,s,M;
 char	*split,*tmp, *keys,*SRC,*DES;
 int	lstack[STACK_SIZE_QS];
 int	rstack[STACK_SIZE_QS];

  if (n <= 1) return;
  keys  = (char *) akeys;
  tmp   = (char *) malloc(size*sizeof(char));
  split = (char *) malloc(size*sizeof(char));
#ifdef SANITY_CHECK
  check_if_null(tmp,  "g55non1","tmp");
  check_if_null(split,"g55non1","split");
#endif
  s=0;
  lstack[0]=0;rstack[0]=n-1;
do {
    l=lstack[s]; r=rstack[s]; s--;
    do {
	i=l;
	j=r;
	MEMCPY(split,&keys[((l+r)>>1)*size],size);

	do {
          while (compare(&keys[i*size],split) < 0) i++;
          while (compare(split,&keys[j*size]) < 0) j--;

	  if (i <= j ) {
            MEMCPY(tmp,&keys[i*size],size);
            MEMCPY(&keys[i*size],&keys[j*size],size);
            MEMCPY(&keys[j*size],tmp,size);
            i++;
            j--;
           }
	} while (i <= j); 
		
	if (i < r) {
          if ((r-i+1) <THRES16 )
	    BASES (&keys[i*size],(r-i+1),size,compare);
          else {
	    s++; lstack[s]=i; rstack[s]=r;
          }
        }
	r=j;
      } while ( l < r);

   } while (s>= 0);

 free((void *)split); free((void *)tmp);
}
