/****   Copyright (c) 1997-2004  Constantionos J. Siniolakis and
 ****                            Alexandros V. Gerbessiotis
 ****
 ****   Permission to use, copy, modify, and distribute this software,
 ****   and to incorporate it, in whole or in part, into other software,
 ****   is hereby granted without fee, provided that
 ****     (1) the above copyright notice and this permission notice appear in
 ****         all copies of the source code, and the above copyright notice
 ****         appear in clearly visible form on all supporting documentation
 ****         and distribution media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects; use this code on your own personal risk
 ****/

#include        "issrt.h"

void rdxs32i(int n,unsigned int mx_int,int *sbits,int *nbits)
{
  register int tmp;
  *sbits = CLog2(mx_int); *nbits = FLog2(n);
  tmp = CDiv(*sbits, *nbits); *nbits = CDiv(*sbits, tmp);
  if (*nbits >= (*sbits - 1)) *nbits = *sbits;
}

void rdxs32 (unsigned int *src,int n,unsigned int mx_int)
{
  register int *trg, *cnt;
  register int  lbit, rbits;
  int sbits,nbits;
  register int i,j, idx,r;
 
  if ((n <= 1)||(mx_int <= 0)) return;

  trg= (int *) malloc(n*sizeof(int));
#ifdef SANITY_CHECK
 check_if_null((void *)trg,"rdxs32","trg");
#endif

  if (n > mx_int) {
    r=mx_int+1;
    cnt=(int *) malloc(r*sizeof(int));
#ifdef SANITY_CHECK
    check_if_null((void *)cnt,"rdxs32","cnt"); 
#endif
    memset(cnt,0,r*sizeof(int));
    for(j=0;j<n;++j) cnt[src[j]]++;
    for(i=1;i<r;++i) cnt[i] += cnt[i-1];
    for(j=n-1;j>=0;--j) {
      idx = --cnt[src[j]];
      trg[idx] = src[j];
    }
    memcpy(src, trg, n * sizeof(int));
    free((void *)cnt);
  } 
  else {
    rdxs32i(n, mx_int, &sbits, &nbits);
    rbits = nbits; r = Exp2(rbits) + 1;
    cnt= (int *) malloc(r*sizeof(int));
#ifdef SANITY_CHECK
    check_if_null((void *)cnt,"rdxs32","cnt"); 
#endif
    for (lbit=0;lbit<sbits;lbit += rbits) {
      rbits = MIN(nbits, sbits - lbit); r = Exp2(rbits) + 1;
      memset(cnt,0,r*sizeof(int));
      for (j=0;j<n;++j)  cnt[Mask(src[j], lbit, rbits)]++;
      for (i=1;i<r;++i)  cnt[i] +=  cnt[i-1];
      for (j=n-1;j>=0;j--) {
        idx = --cnt[Mask(src[j], lbit, rbits)];
        trg[idx] = src[j];
      }
      memcpy(src, trg, n * sizeof(int));
   }
    free((void *)cnt);
  }

  free((void *)trg);
}

void i32rdx ( unsigned int *src, int n )
{
  rdxs32(src, n, 2147483647);
}

