/****   Copyright (c) 1997-2004  Constantionos J. Siniolakis and
 ****                            Alexandros V. Gerbessiotis
 ****
 ****   Permission to use, copy, modify, and distribute this software,
 ****   and to incorporate it, in whole or in part, into other software,
 ****   is hereby granted without fee, provided that
 ****     (1) the above copyright notice and this permission notice appear in
 ****         all copies of the source code, and the above copyright notice
 ****         appear in clearly visible form on all supporting documentation
 ****         and distribution media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects; use this code on your own personal risk
 ****/

#include        "issrt.h"

void i32rdx4(unsigned int *src,int n)
{
  unsigned int *trg;
  int   cnt[256];
  register int          i,r;
  register int          j,idx;
  
  if (n <= 1) return;
  trg= (unsigned int *) malloc(n*sizeof(unsigned int));
#ifdef SANITY_CHECK
  check_if_null((void *)trg,"i32rdx4","trg");
#endif
  r = 256;
  memset(cnt,0,r*sizeof(int)); 
  for (j=0;j<n;j++) cnt[src[j] & 0x000000FF]++; 
  for (i=1;i<r;i++) cnt[i] += cnt[i-1];
  for (j=n-1;j>=0;j--) {
      idx= --cnt[src[j] & 0x000000FF]; 
      trg[idx]=src[j];
  }

  r = 256;
  memset(cnt,0,r*sizeof(int)); 
  for (j=0;j<n;j++)  cnt[(trg[j] >> 8) & 0x000000FF ]++;
  for (i=1;i<r;i++) cnt[i] += cnt[i-1];
  for (j=n-1;j>=0;j--) {
      idx = --cnt[(trg[j] >> 8) &  0x000000FF];
      src[idx] = trg[j];
  }

  r = 256;
  memset(cnt,0,r*sizeof(int)); 
  for (j=0;j<n;j++)  cnt[(src[j] >> 16) & 0x000000FF ]++;
  for (i=1;i<r;i++) cnt[i] += cnt[i-1];
  for (j=n-1;j>=0;j--) {
      idx = --cnt[(src[j] >> 16) & 0x000000FF ];
      trg[idx] = src[j];
  }

  r = 256;
  memset(cnt,0,r*sizeof(int)); 
  for (j=0;j<n;j++)  cnt[trg[j] >> 24]++;
  for (i=1;i<r;i++) cnt[i] += cnt[i-1];
  for (j=n-1;j>=0;j--) {
      idx = --cnt[trg[j] >> 24];
      src[idx] = trg[j];
  }

  free((void *)trg);
}
