/****   Copyright (c) 1997-2005  Constantionos J. Siniolakis and
 ****                            Alexandros V. Gerbessiotis
 ****
 ****   Permission to use, copy, modify, and distribute this software,
 ****   and to incorporate it, in whole or in part, into other software,
 ****   is hereby granted without fee, provided that
 ****     (1) the above copyright notice and this permission notice appear in
 ****         all copies of the source code, and the above copyright notice
 ****         appear in clearly visible form on all supporting documentation
 ****         and distribution media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects; use this code on your own personal risk
 ****/

#include "issrt.h"
#define  Parent(i)   ((i-1)>>1)
#define  Left(i)     ((i<<1)+1)
#define  Right(i)    ((i<<1)+2)


void Heapifyi(idata *heap,int nelems,int i,idata tmp)
{
  register int  l, r;
  register int  tind;

  l = Left(i) ;
  r = Right(i) ;

  if ((l < nelems) && (heap[l]>heap[i]))
       tind = l ;
  else tind = i ;
  if ((r < nelems) && (heap[r]>heap[tind]))
       tind = r ;

  if (tind != i)
    {
      tmp=heap[i];
      heap[i]=heap[tind];
      heap[tind]=tmp;
      Heapifyi(heap, nelems, tind,tmp);
    }
}

void Build_Heapi(idata  *heap, int nelems)
{
  register idata tmp=0;
  register int  i;

  for (i = nelems - 1 ; i >= 0 ; --i)
    {
      Heapifyi(heap, nelems, i,tmp);
    }
}

	
void i44hx(idata *keys, int n)
{
 register idata tmp=0;
 register int i;

 Build_Heapi(keys,n);
 for (i = n-1;i>=1;--i){
  tmp=keys[0];
  keys[0]=keys[i];
  keys[i]=tmp;
  Heapifyi(keys,i,0,tmp);
  }
}
