/****Copyright (c) 1997-2005 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "issrt.h"

void A52dbh   (idata *keys, int n, int l,int r)
{
 register idata split,tmp;
 register int i,j;

 if (n<=1) return;
 i=l;j=r;
#if   SPLITTER == MIDDLE_KEY
 split=keys[(l+r)/2];
#elif SPLITTER == FIRST_KEY
 split=keys[l];
#elif SPLITTER == RANDOM_KEY
 split=keys[l+GRANDOM((r-l+1))];
#endif

 do {
   while (keys[i]<split) i++;
   while (split<keys[j]) j--;
   if (i <= j ) {
     tmp=keys[i];
     keys[i]=keys[j];
     keys[j]=tmp;
     i++;j--;
   }
 } while (i <= j);
	
 if (l < j) {
   if ((j-l) < THRESI16) {
     BASEI(&keys[l],(j-l+1));
   }
   else {
     A52dbh   (keys,n,l,j);
   }
 }
 if (i < r) {
   if ((r-i) < THRESI16) {
      BASEI  (&keys[i],(r-i+1));
   }
   else {
      A52dbh   (keys,n,i,r);
   }
 }
}

void i52dbh  (idata *keys, int n)
{
 if (n <= 1) return;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
 A52dbh   (keys,n,0,n-1);
}
