/****Copyright (c) 1997-2014 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/

#include <memory.h>
#include <limits.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

typedef int    data;
#define PRINT_INT 1
#define Times2(x)            ((x) << 1)


/* Date: Jun 23, 2005 */
#ifndef TRUE
#define TRUE            1
#endif
#ifndef FALSE
#define	FALSE		0
#endif
#ifndef MIN
#define	MIN(x,y)	((x)<=(y)?(x):(y)) 
#endif
#ifndef MAX
#define	MAX(x,y)	((x)>=(y)?(x):(y))
#endif
#ifndef CEIL
#define CEIL(X,Y)       ((X != 0)?(1+ (X-1)/Y):0)  
#endif
#ifndef FLOOR
#define FLOOR(X,Y)      (X/Y)  
#endif

#define check_if_null(X,Y,Z)  avg_checknull(X,Y,Z);
#define GRANDOM(X)  (int)((random()/((double)2147483647.0))*X)
#define GSRANDOM()   srandom((unsigned int)time(NULL))
#define STACK_SIZE_QS 64
#define STSZ STACK_SIZE_QS
#define MAX_KEY_SIZE  64   /* in bytes*/
#define THRES16   24 /*  NEW: 24 or 16 but for dsort use 8 */
                     /*   OLD: 16 or 24: 48,g21ins for PIV/III Linux , 8-16 for SUNS for MERGE */
#define TMERGE     8  /* Threshold for MERGE SORT; 16 or 8 might better than  24 */
#define MERGE16   TMERGE
#define THRESI16 24  /* 20 for non1 24 for other */
#define TMERGEI  8   /* THRESHOLD FOR MERGESORT 8 -64 ok */
#define BASES   g21ins  
#define BASEI   i01ins /* Function For Base Sorting in Integer Quick Sort */
#define FIRST_KEY  0
#define MIDDLE_KEY 1
#define RANDOM_KEY 2
#define SPLITTER  MIDDLE_KEY
#undef ALTERNATIVE

void avg09qn(void *,int ,int ,int (*)(const void*,const void*));
void avg10qn(void *,int ,int ,int (*)(const void*,const void*));
void avg11qn(void *,int ,int ,int (*)(const void*,const void*));
void avg12qn(void *,int ,int ,int (*)(const void*,const void*));
void avg13qd(void *,int ,int ,int (*)(const void*,const void*));
void avg14qw(void *,int ,int ,int (*)(const void*,const void*));
void avg15qw(void *,int ,int ,int (*)(const void*,const void*));
void avg16qf(void *,int ,int ,int (*)(const void*,const void*));
void avg17qf(void *,int ,int ,int (*)(const void*,const void*));
void avg20qw(void *,int ,int ,int (*)(const void*,const void*));
void avg30mi(void *,int ,int ,int (*)(const void*,const void*));
void avg31mi(void *,int ,int ,int (*)(const void*,const void*));
void avg34mi(void *,int ,int ,int (*)(const void*,const void*));
void avg35mi(void *,int ,int ,int (*)(const void*,const void*));
void avg40mi(void *,int ,int ,int (*)(const void*,const void*));
void avg41mi(void *,int ,int ,int (*)(const void*,const void*));
void avg43hx(void *,int ,int ,int (*)(const void*,const void*));
void avg45hx(void *,int ,int ,int (*)(const void*,const void*));

void avg50qw(void *,int ,int ,int (*)(const void*,const void*));
void avg51qd(void *,int ,int ,int (*)(const void*,const void*));
void avg59qw(void *,int ,int ,int (*)(const void*,const void*));
void oavg50qw(void *,int ,int ,int (*)(const void*,const void*));
void oavg51qd(void *,int ,int ,int (*)(const void*,const void*));
void oavg59qw(void *,int ,int ,int (*)(const void*,const void*));
void ravg50qw(void *,int ,int ,int (*)(const void*,const void*));
void ravg51qd(void *,int ,int ,int (*)(const void*,const void*));
void ravg59qw(void *,int ,int ,int (*)(const void*,const void*));

void oavg09qn(void *,int ,int ,int (*)(const void*,const void*));
void oavg10qn(void *,int ,int ,int (*)(const void*,const void*));
void oavg11qn(void *,int ,int ,int (*)(const void*,const void*));
void oavg12qn(void *,int ,int ,int (*)(const void*,const void*));
void oavg13qd(void *,int ,int ,int (*)(const void*,const void*));
void oavg14qw(void *,int ,int ,int (*)(const void*,const void*));
void ravg13qd(void *,int ,int ,int (*)(const void*,const void*));
void ravg14qw(void *,int ,int ,int (*)(const void*,const void*));
void oavg15qw(void *,int ,int ,int (*)(const void*,const void*));
void oavg16qf(void *,int ,int ,int (*)(const void*,const void*));
void oavg20qw(void *,int ,int ,int (*)(const void*,const void*));
void oavg21qw(void *,int ,int ,int (*)(const void*,const void*));
void oavg30mi(void *,int ,int ,int (*)(const void*,const void*));
void oavg31mi(void *,int ,int ,int (*)(const void*,const void*));
void oavg34mi(void *,int ,int ,int (*)(const void*,const void*));
void oavg35mi(void *,int ,int ,int (*)(const void*,const void*));
void oavg40mi(void *,int ,int ,int (*)(const void*,const void*));
void oavg41mi(void *,int ,int ,int (*)(const void*,const void*));
void oavg43hx(void *,int ,int ,int (*)(const void*,const void*));
void oavg45hx(void *,int ,int ,int (*)(const void*,const void*));


void gnu01  (void *,int ,int ,int (*)(const void*,const void*));
void gnu02  (void *,int ,int ,int (*)(const void*,const void*));

void g01ins  (void *,int ,int ,int (*)(const void*,const void*));
void g02ins  (void *,int ,int ,int (*)(const void*,const void*));
void g04sel  (void *,int ,int ,int (*)(const void*,const void*));
void g05bub  (void *,int ,int ,int (*)(const void*,const void*));
void g06bins (void *,int ,int ,int (*)(const void*,const void*));
void g07shake(void *,int ,int ,int (*)(const void*,const void*));
void g08shell(void *,int ,int ,int (*)(const void*,const void*));
void g09shlln(void *,int ,int ,int (*)(const void*,const void*));
void g11ins  (void *,int ,int ,int (*)(const void*,const void*));
void g12ins  (void *,int ,int ,int (*)(const void*,const void*));
void g14sel  (void *,int ,int ,int (*)(const void*,const void*));
void g21ins  (void *,int ,int ,int (*)(const void*,const void*));
void g22ins  (void *,int ,int ,int (*)(const void*,const void*));
void g24sel  (void *,int ,int ,int (*)(const void*,const void*));
void g25bub  (void *,int ,int ,int (*)(const void*,const void*));
void g26bins (void *,int ,int ,int (*)(const void*,const void*));
void g27shake(void *,int ,int ,int (*)(const void*,const void*));
void g28shell(void *,int ,int ,int (*)(const void*,const void*));
void g20mrgit(void *,int ,int ,int (*)(const void*,const void*));
void g77shake(void *,int ,int ,int (*)(const void*,const void*));
void g78shell(void *,int ,int ,int (*)(const void*,const void*));

void i01ins  (        data *, int); 
void i30mrgit(        data *, int); 
void i32rdx2 (unsigned int *, int);
void i32rdx4 (unsigned int *, int);
void i32rdx  (unsigned int *, int); 
void i33heapx(        data *, int); 
void i34heapx(        data *, int); 
void i35heapn(        data *, int); 
void i35heapx(        data *, int); 
void i36heapn(        data *, int); 
void i36heapx(        data *, int); 

void i50gnu  (void *,int ,int ,int (*)(const void*,const void*));
void i51wbh (        data *, int); 
void i52dbh (        data *, int); 
void i55non0(        data *, int); 
void i55non1(        data *, int); 
void i63fbc (        data *, int); 

/* NEWNEW */
void ag70qsnt(void *,int ,int ,int (*)(const void*,const void*));
void ag71qsrt(void *,int ,int ,int (*)(const void*,const void*));
void ag72qsnt(void *,int ,int ,int (*)(const void*,const void*));
void ag73qsnt(void *,int ,int ,int (*)(const void*,const void*));
void ag74mrgit(void *,int ,int ,int (*)(const void*,const void*));
void ag75mrgnn(void *,int ,int ,int (*)(const void*,const void*));
void ag76heapx(void *,int ,int ,int (*)(const void*,const void*));
void ag77shake(void *,int ,int ,int (*)(const void*,const void*));
void ag78shell(void *,int ,int ,int (*)(const void*,const void*));
void bg20mrgit(void *,int ,int ,int (*)(const void*,const void*));
void bg21mrgnn(void *,int ,int ,int (*)(const void*,const void*));
void bg30heapn(void *,int ,int ,int (*)(const void*,const void*));
void bg31heapn(void *,int ,int ,int (*)(const void*,const void*));
void bg32heapx(void *,int ,int ,int (*)(const void*,const void*));
void bg33heapx(void *,int ,int ,int (*)(const void*,const void*));
void bg34heapx(void *,int ,int ,int (*)(const void*,const void*));
void bg40rqst(void *,int ,int ,int (*)(const void*,const void*));
void bg42qsrn(void *,int ,int ,int (*)(const void*,const void*));
void bg43qsrt(void *,int ,int ,int (*)(const void*,const void*));
void bg44qsrt(void *,int ,int ,int (*)(const void*,const void*));
void bg45qsrn(void *,int ,int ,int (*)(const void*,const void*));
void bg46qsrt(void *,int ,int ,int (*)(const void*,const void*));
void bg47qsrt(void *,int ,int ,int (*)(const void*,const void*));
void bg48qsrt(void *,int ,int ,int (*)(const void*,const void*));
void bg50qsnn(void *,int ,int ,int (*)(const void*,const void*));
void bg51qsnt(void *,int ,int ,int (*)(const void*,const void*));
void bg52qsnt(void *,int ,int ,int (*)(const void*,const void*));
void bg53qsnt(void *,int ,int ,int (*)(const void*,const void*));
void bg54qsnt(void *,int ,int ,int (*)(const void*,const void*));
void bg55qsnt(void *,int ,int ,int (*)(const void*,const void*));
void bg56qsnt(void *,int ,int ,int (*)(const void*,const void*));
void cg30mrgit(void *,int ,int ,int (*)(const void*,const void*));
void cg31mrgnn(void *,int ,int ,int (*)(const void*,const void*));
void cg36heapx(void *,int ,int ,int (*)(const void*,const void*));
void cg37heapx(void *,int ,int ,int (*)(const void*,const void*));
void cg39mrgit(void *,int ,int ,int (*)(const void*,const void*));
void cg53fbc(void *,int ,int ,int (*)(const void*,const void*));
void dg61wbh(void *,int ,int ,int (*)(const void*,const void*));
void dg62dbh(void *,int ,int ,int (*)(const void*,const void*));
void dg66non1(void *,int ,int ,int (*)(const void*,const void*));
void dg67(void *,int ,int ,int (*)(const void*,const void*));
void dg68non1(void *,int ,int ,int (*)(const void*,const void*));
void dg68non2(void *,int ,int ,int (*)(const void*,const void*));
void dg69non1(void *,int ,int ,int (*)(const void*,const void*));
void g153fbc(void *,int ,int ,int (*)(const void*,const void*));
void g154fbc(void *,int ,int ,int (*)(const void*,const void*));
void g161wbh(void *,int ,int ,int (*)(const void*,const void*));
void g162dbh(void *,int ,int ,int (*)(const void*,const void*));
void g168non1(void *,int ,int ,int (*)(const void*,const void*));
void g168wbh(void *,int ,int ,int (*)(const void*,const void*));
void g170my3(void *,int ,int ,int (*)(const void*,const void*));
void g170my4(void *,int ,int ,int (*)(const void*,const void*));
void g170my5(void *,int ,int ,int (*)(const void*,const void*));
void g253fbc(void *,int ,int ,int (*)(const void*,const void*));
void g266non2(void *,int ,int ,int (*)(const void*,const void*));
void g268non1(void *,int ,int ,int (*)(const void*,const void*));
void g268non2(void *,int ,int ,int (*)(const void*,const void*));
void g268wbh(void *,int ,int ,int (*)(const void*,const void*));
void g33heapx(void *,int ,int ,int (*)(const void*,const void*));
void g33heapx2004(void *,int ,int ,int (*)(const void*,const void*));
void g34heapx(void *,int ,int ,int (*)(const void*,const void*));
void g35heapn(void *,int ,int ,int (*)(const void*,const void*));
void g35heapx(void *,int ,int ,int (*)(const void*,const void*));
void g36heapn(void *,int ,int ,int (*)(const void*,const void*));
void g36heapx(void *,int ,int ,int (*)(const void*,const void*));
void g37heapx(void *,int ,int ,int (*)(const void*,const void*));
void g50gnu(void *,int ,int ,int (*)(const void*,const void*));
void g51wbh(void *,int ,int ,int (*)(const void*,const void*));
void g52dbh(void *,int ,int ,int (*)(const void*,const void*));
void g53fbc(void *,int ,int ,int (*)(const void*,const void*));
void g55non1(void *,int ,int ,int (*)(const void*,const void*));
void g61wbh(void *,int ,int ,int (*)(const void*,const void*));
void g62dbh(void *,int ,int ,int (*)(const void*,const void*));
void g63fbc(void *,int ,int ,int (*)(const void*,const void*));
void g65non1(void *,int ,int ,int (*)(const void*,const void*));
void g65non2(void *,int ,int ,int (*)(const void*,const void*));
void g65non3(void *,int ,int ,int (*)(const void*,const void*));
void g66non1(void *,int ,int ,int (*)(const void*,const void*));
void g66non2(void *,int ,int ,int (*)(const void*,const void*));
void g67(void *,int ,int ,int (*)(const void*,const void*));
void g68non1(void *,int ,int ,int (*)(const void*,const void*));
void g68non2(void *,int ,int ,int (*)(const void*,const void*));
void g68wbh(void *,int ,int ,int (*)(const void*,const void*));
void g69non1(void *,int ,int ,int (*)(const void*,const void*));
void my1(void *,int ,int ,int (*)(const void*,const void*));
void my2(void *,int ,int ,int (*)(const void*,const void*));
void my3(void *,int ,int ,int (*)(const void*,const void*));
void my4(void *,int ,int ,int (*)(const void*,const void*));
void my5(void *,int ,int ,int (*)(const void*,const void*));


/* NEWNEW */

#define SWAPP(i1,i2) \
  {ii = size;do {k = *(i1);*(i1)++ = *(i2);*(i2)++ = k;} while(--ii);}
#define SWAPPY(XX,YY,TT,SS) {DES=(XX);SRC=(YY);M=(SS); do {*TT=*DES;*DES++=*SRC;*SRC++=*TT;} while ( --M); }

#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#undef MEMCPY
#define MEMCPY(XX,YY,SS) {DES=(XX);SRC=(YY);M=(SS); do {*DES++=*SRC++;} while (--M); }
#define IMEMCPY(XX,YY,SS) {DES=(XX);SRC=(YY);M=(SS); do {*DES++=*SRC++;} while (--M); }
