/*******************************************************************
*******  Copyright (c)            Alexandros V. Gerbessiotis       *
******* All rights reserved; read copyag.txt file                  *
*******************************************************************/
#include "ssrt.h"
/* Standard quicksort(Hoare) with inline memcpy (mostly) and insertion sort  :LUNATIC but ...*/

/* 
 char* med50(char *a, char *b, char *c, int (*cmp)(const void *, const void *)) {
       return cmp(a, b) < 0 ?  (cmp(b, c) < 0 ? b : (cmp(a, c) < 0 ? c : a ))
                            :  (cmp(b, c) > 0 ? b : (cmp(a, c) < 0 ? a : c ));
 }
*/


void avg50qwm(void *akeys, int size,int (*compare)(const void*,const void*), int *L,int *R)
{
  register int  M,c,l,r,mL,mR;
  register char *pi,*pl,*pr,*pp,*jp, *DES,*SRC;
  register char *keys=(char *) akeys, *split;


  if ((*R-*L) <= 0) return ; /* if ((*R-*L+1) <= 1) return ; */
  split = (char*) malloc(size*sizeof(char));


   mL=*L;mR=*R;
  while (mL < mR ) { 
     l=mL;r=mR;
     pl=keys+l*size; 
     pr=keys+r*size;
/*
     pm=keys+((l+r)/2)*size;
     pm = med50(pl, pm , pr,compare);
     MEMCPY(split,pm,size);
*/
#if SPLITTER == MIDDLE_KEY
    MEMCPY(split,&keys[((l+r)>>1)*size],size);
#elif SPLITTER == FIRST_KEY
    MEMCPY(split,&keys[l*size],size);
#elif SPLITTER == RANDOM_KEY
    MEMCPY(split,&keys[(l+GRANDOM((r-l+1)))*size],size);
#endif

     while (l <= r) {
         while (compare(pl,split)<0) {l++;pl +=size;}
         while (compare(split,pr)<0) {r--;pr -=size;}
         if (l <= r) { /* is it ok if < ? */
/*
	     MEMCPY(tmp,pl,size);
	     MEMCPY(pl,pr,size);
	     MEMCPY(pr,tmp,size);
    	     l++;r--;pl += size; pr -= size;
*/
               M=size;
               do {
                c=*pl; *pl++ = *pr; *pr++=c; } while (--M);
               l++; pr -=size;
               r--; pr -=size;
         }
     }
  
   if ((r-mL) < (mR-l)) { /* Left side smaller; eliminated a +1 from both sides */
      if ((r-mL+1) < THRES16) {
                 if ((r-mL) >0) {   /* usedto be r-mL+1 > 1 */
                  pi=keys+mL*size;
                  for(jp=pi+size; jp< pi+(r-mL+1)*size; jp +=size){
                    MEMCPY(split,jp,size);
                    for(pp=jp; pp >pi && (compare(pp-size,split)>0) ; pp-=size) {
                     MEMCPY((pp),(pp-size),size);
                    }
                    MEMCPY((pp),split,size);
                  }
                 }
          mL=l;
      }
      else {
         *R=r; *L=mL; /* mL...r */
/*
         avg50qwm(keys,(r-mL+1),size,compare,L,R);
*/
         avg50qwm(keys,size,compare,L,R);
         mL=l;  /* OR r l ..mR */
      }
   } /*left */
  else {               /* Right side smaller */
      if ((mR-l+1) < THRES16) {
                          if ((mR-l) >0) { /* used to be mR-l+1 >1 */
               pi=keys+l*size;
               for(jp=pi+size;jp<pi+(mR-l+1)*size;jp+=size){
                    MEMCPY(split,jp,size);
                    for(pp=jp; pp >pi && (compare(pp-size,split)>0) ; pp-=size) {
                     MEMCPY((pp),(pp-size),size);
                    }
                    MEMCPY((pp),split,size);
               }
              }
       mR=r;
      }
      else {
        *L=l; *R=mR;  /* l...mR */
/*
        avg50qwm(keys,mR-l+1,size,compare,L,R);
*/
        avg50qwm(keys,size,compare,L,R);
        mR=r;  /* mL ...r */
      }
      
  } /*right*/
 }


}

void avg50qw(void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  int myL,myR;
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  myL=0;myR=n-1;
  avg50qwm(keys,size,compare,&myL,&myR);
}



/************************
 * Note : code differs from CLR Hoare code in the following respect
 *  say input 10 9 8 7 5 and splitter is middle key 8
 *  at termination we have say l=1 r=5 in the beginning
 *            6 7  8 9 10
 *              r    l
 *  lest partition is 6 7 and right partion is ? 9 10 or  8 9 10?
 *  if all keys are equal
 *            8 8  8  8 8 
 *              r     l   at termination
 *  In the g67.c code which is similar (but original and possibly primitive)
 *  left set is L ... r of size r-L+1   base left set keys[L*size]
 *  righ set is l ... R of size R-l+1 correctly identifies keys[l*size]
 *  if g68 and also by extension in g268 we used (pending before potential changes)
 *  left set is size r+1 and right set of size n-l which does not make much sense.
 */
